function [Cent,AvgInt,Img,Boxulx,Boxuly,BoxW,BoxH,contourPxy,DCEXC,DCEYR,DCE6XC,DCE6YR,contstartP2,contendP2,Ordfill,BW2] = MAINPROGRAMCEN(A,imagename,corC,corR,number,thrFac,ImgScale,halfsizeR,halfsizeC,ImgType,figflag)
%Author - AKILA MIKE SUBASINGHE
%This Program makes all necessary Function calls in order to detect the
%Medial Axis Accurately and to Calculate the Ratios
%==========================================================================
%==========================================================================
%INITIAL SET UP - START
%clear all
close all
clc

center = '_xy_center_';
methods = '_Centerline';
centerprun = '_xy_center_prunned_';
bench = '_xy_bench_';
length = '_length_';
final = '_result_';
centroPos = '_CentroPos_';
numb1 = int2str(number);
Formatt = '.txt';
Formati = '.TIF';
CENTRO = '_CENTRO_';
fname1 = 'New.pgm';

baseimage = '_BASEIMAGE';

% centername = [imagename center numb1 Formatt];
% centerprunname = [imagename centerprun numb1 Formatt];
% benchname = [imagename bench numb1 Formatt];
% lengthname = [imagename length numb1 Formatt];
% centroPosname = [imagename centroPos numb1 Formatt];
% CENTROname = [imagename CENTRO numb1 Formatt];
% 
% fidcenter = fopen(centername,'w');
% fidcenterprun = fopen(centerprunname,'w');
% fidbench = fopen(benchname,'w');
% fidlengths = fopen(lengthname,'w');
% fidcentroPos = fopen(centroPosname,'w');
% fidCENTRO = fopen(CENTROname,'w');
foldn = pwd;
foldrName = [foldn '\IMAGE_RESULTS\']

%finalimage = [numb1 methods Formati];
finalimage = [foldrName numb1 'Segmentation' Formati];

%baseimage = [numb1 baseimage Formati];
baseimage = [foldrName numb1 baseimage Formati];

%path
%path(path,'C:/Documents and Settings/akila/My Documents/MATLAB/INTEGRATE/WITH USER INPUTS/SKELETON')
%path(path,'C:/Documents and Settings/akila/My
%Documents/MATLAB/INTEGRATE/WITH USER INPUTS/SNAKE')
%Parameters Controlling the Window SIZE..Each is Half (1/2) the actual W/H
%halfsizeR = 100;
%halfsizeC = 100;
%thrFac = 1.10;
%ImgScale = 1.00; %This value should be in nm (The Length or Width of 1
%Pixel)
%INITIAL SET UP - DONE
%==========================================================================
%==========================================================================
%IMAGE SELECTION,PRE-PROCESSING - START
% A = imread(imagename);
% szA = size(A);
% if(size(szA,2)>2)
%     A = rgb2gray(A);
% end
% 
% if (ImgType==1)
% A = 255 - A;    %WHEN THE IMAGES ARE INVERTED IMAGES.
% end





%A = 255 - A;    %WHEN THE IMAGES ARE INVERTED IMAGES.
minY = corR-halfsizeR;
minX = corC-halfsizeC;
COMB = imcrop(A,[minX minY (2*halfsizeR) (2*halfsizeC)]);
COMB = imadjust(COMB);
basel = thrFac*graythresh(COMB);
BWT = im2bw(COMB, basel);
%figure, imshow(BWT,[])%title('BINARY IMAGE')
AT = bwselect(BWT,halfsizeR,halfsizeC,4);
ObjInd = find(AT);
Selsize = size(ObjInd,1);

if (Selsize<2)
    [AT]=myLabelObjExtract(COMB,BWT,halfsizeC,halfsizeR);
end

[FO] = myPreProcess(COMB);
Img = FO;
imwrite(FO,fname1);
%IMAGE SELECTION,PRE-PROCESSING - DONE
%==========================================================================
%==========================================================================
%GVF SNAKE,PATH FINDING,PRUNNING - START

[I,map] = rawread(fname1);
[BW2,contourPxy] = CentreofOPS2(I,AT);


STATS = regionprops(BW2, 'BoundingBox');
AAA =  STATS.BoundingBox;
Boxulx = AAA(1);
Boxuly = AAA(2);
BoxW = AAA(3);
BoxH = AAA(4);


% pause
% 
% figure
% imshow(BW2,[])
% hold on
% drx1 = [Boxulx Boxulx+(BoxW)];
% dry1 = [Boxuly Boxuly];   
% drx2 = [Boxulx+(BoxW) Boxulx+(BoxW)];
% dry2 = [Boxuly Boxuly+(BoxH)];    
% drx3 = [Boxulx+(BoxW) Boxulx];
% dry3 = [Boxuly+(BoxH) Boxuly+(BoxH)];    
% drx4 = [Boxulx Boxulx];
% dry4 = [Boxuly+(BoxH) Boxuly];
% 
% plot(drx1,dry1,'Color','y','LineStyle','-');
% hold on
% plot(drx2,dry2,'Color','y','LineStyle','-');
% hold on
% plot(drx3,dry3,'Color','y','LineStyle','-');
% hold on
% plot(drx4,dry4,'Color','y','LineStyle','-');
% hold off
% pause
                    
                    

BWthin = bwmorph(BW2,'thin',Inf);
BWskel = bwmorph(BW2,'skel',Inf);
%[FPath,Flength,bwx] = myBranchFinding(BW2,I);
[FPath,Flength,bwx,DCEXC,DCEYR,DCE6XC,DCE6YR] = myBranchFindingOLD(BW2,I);



%GVF SNAKE,PATH FINDING,PRUNNING - DONE
%==========================================================================
%==========================================================================
%SAMPLING POINTS ON THE SKELETON - START
intskllng = size(FPath,1);
% if(intskllng<40)
%     [Z] = thintrace(BWthin);
%     FPath = Z;
%     disp('HYBRID CRITERIA MET')
% end
Flength = size(FPath,1);
[fac pnts smpWidth] = mySpacingCalc(FPath,intskllng);
[SamP]= mySample(FPath,pnts,fac);
SampR = SamP(:,2);
SampC = SamP(:,1);
Lend = 1 + fac;
Hend = Flength - fac;

%%% CHANGED NOT TO PRUN CENTERLINE %%%
%FPathS = FPath(Lend:Hend,:);
FPathS = FPath;



%save (fname2,'FPath','I','bw2thin')
%save(filenames, 'SamP', 'SampR','SampC','I','pnts')
% figure
% imshow(I,[])
% hold on
% plot(SampC,SampR,'*')
% hold off


%SAMPLING POINTS ON THE SKELETON - DONE
%==========================================================================
%==========================================================================
%SAMPLING POINTS ON SPLINE FIT - START

% [OrdfillInt,spnts2] = SplineTempMine2XY(I,SamP,FPathS,pnts);
% [OrdfillInt,spnts2] = myRemoveDuplics(OrdfillInt);
OrdfillInt = FPathS;

%SAMPLING POINTS ON SPLINE FIT - DONE
%==========================================================================
%==========================================================================
%CORRECTING THE END POINTS AND SAMPLING - START
%padFac = smpWidth + 10;
%[Ordfill,spnts3,szseg1,szseg2] = Col7(I,SamP,OrdfillInt,smpWidth,padFac);
Ordfill = OrdfillInt; % PS - ASANKA -> Un comment the above 2 lines and comment this line to use end pnt correction.

% smpWidth;
% disp('----------------')
% disp('Final Results')

% if(~isempty(spnts3))
%     Totpnts = spnts2+spnts3;
% else
%     Totpnts = spnts2;
% end

%CORRECTING THE END POINTS AND SAMPLING - DONE
%==========================================================================
%==========================================================================
%GETTING EUCLEDIAN LENGTHS - START
% disp('----------------')
% disp('The Eucledian Length')
% [EUL] = myEuclLength(Ordfill,ImgScale)
% disp('----------------')

%GETTING EUCLEDIAN LENGTHS - DONE
%==========================================================================
%==========================================================================
%FINDING THE CONTROMERE - START

[Cent,AvgInt,contstartP2,contendP2] = myCentroFind(I,BW2,OrdfillInt,figflag);
BackupC = OrdfillInt;

%0000000000000000000000000000000000000000000
% figure
% plot(Cent(:))
% title('Width Profile')
% saveas(gcf,'WidthProfile.tif')
% 
% figure
% plot(AvgInt(:))
% title('Intensity Profile')
% saveas(gcf,'IntensityProfile.tif')
%0000000000000000000000000000000000000000000

maxR = max(AvgInt(:));
maxSm = max(Cent(:));
minR = 0;

% vr =size(Cent,1);
% diff =maxR-minR
% diff(diff ==0) =1;% Avoid dividing by zero
% scCent =(Cent-repmat(minR, vr,1))./(repmat(diff,vr,1))*maxR;

scCent = Cent.*(maxR/maxSm);   

FCentR = scCent+AvgInt;

% figure
% plot(scCent(:))
% title('SCALED UP!')
% 

%0000000000000000000000000000000000000000000
% figure
% plot(FCentR(:))
% title('Result Profile')
% saveas(gcf,'ResultProfile.tif')
%0000000000000000000000000000000000000000000

minCent = min(FCentR(:));       %minimum RESULT value 
minInd = find(FCentR==minCent); %indices of the minimum value
minindS = size(minInd,1);       %number of minimum occurances

if(minindS>1)
    Cmidind = minInd(floor(minindS/2));
else
    Cmidind = minInd;
end

%Cminind - the median of the minimum value occurance

OrdfX = OrdfillInt(:,1);
OrdfY = OrdfillInt(:,2);

midLen = size(OrdfX,1);         %Length of the segment used for CI calc.

centX = OrdfX(Cmidind);     %X coordinate of the median minm val
centY = OrdfY(Cmidind);     %Y coordinate of the median minm val
cind = Cmidind;

%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
%% Second Centromere Finding
% FCentR2 = FCentR;
% OrdfillInt2 = OrdfillInt;
% 
% leftRed  = 22;
% rightRed = 22;
% % PS --> ASANKA, These should also be parameters for the moment.
% 
% Cmidind;
% midLen2 = size(FCentR,1);
% 
% if ((Cmidind - leftRed)<1)
%     leftRed = Cmidind - 1;
% end
% 
% if ((Cmidind + rightRed)>midLen2)
%     rightRed = midLen2 - Cmidind;
% end
% 
% leftInd  = Cmidind - leftRed;
% rightInd = Cmidind + rightRed;
% 
% FCentR2(leftInd:rightInd, :)=[];
% OrdfillInt2(leftInd:rightInd, :)=[];
% 
% minCent2 = min(FCentR2(:));       %minimum RESULT value 
% minInd2 = find(FCentR2==minCent2); %indices of the minimum value
% minindS2 = size(minInd2,1);       %number of minimum occurances
% 
% if(minindS2>1)
%     Cmidind2 = minInd2(floor(minindS2/2));
% else
%     Cmidind2 = minInd2;
% end
% 
% OrdfX2 = OrdfillInt2(:,1);
% OrdfY2 = OrdfillInt2(:,2);
% midLen3 = size(OrdfX2,1);         %Length of the segment used for CI calc.
% centX2 = OrdfX2(Cmidind2);     %X coordinate of the median minm val
% centY2 = OrdfY2(Cmidind2);     %Y coordinate of the median minm val



%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



% widmin = min(Cent(:));
% widProfmin = min(scCent(:));   %Min of the Scaled width profile
% selectoptim = FCentR(Cmidind);  %Selected optimum 
% ECentroV = Cent(Cmidind);       %Selected Centromere 
% widprofgap = size(find(Cent==widmin),1);
% 
% if (widprofgap>1)
%     CENTROCONFID = ((widProfmin + min(AvgInt(:)))/(selectoptim*0.51*widprofgap)) * 100
% else
%     CENTROCONFID = ((widProfmin + min(AvgInt(:)))/(selectoptim)) * 100
% end
% 

%============================================================ 

%%COMMENTED OUT FOR NATASHA's VERSION
% figure
% imshow(I,[])
% hold on
% % plot(Ordfill(:,1),Ordfill(:,2),'y','LineWidth',2)
% % hold on
% % plot(halfsizeC,halfsizeR,'r*','LineWidth',2)
% % hold on
% % plot(Fpair(1),Fpair(2),'b*','LineWidth',2)
% % hold on
% plot(centX,centY,'*b','LineWidth',4)
% hold on
% % plot(centX2,centY2,'b*','LineWidth',3)
% hold off
% title('Centromere Location-Centerline Method')
% %saveas(gcf,strcat(imagename,numb1),'tif')
% saveas(gcf,finalimage,'tif')

close all 

%%whos contourPxy
% 
% close all 
% 
% figure
% imshow(I,[])
% hold on
% plot(contourPxy(:,1),contourPxy(:,2),'b','LineWidth',2)
% hold on
% plot(DCEXC(:),DCEYR(:),'*y','LineWidth',3)
% hold off
% title('Segmentation Result')
% saveas(gcf,finalimage,'tif')
% 
% 
% figure
% imshow(I,[])
% title('Base Image')
% saveas(gcf,baseimage,'tif')







