function  [xypnts,numpnt]=MyEndPoints(xvs,yvs,Qv,xyflag,brkpnt,pntset)
% Author - Akila Mike
% When Provided with the Sample Point values along the line (xvs,yvs-Row Vectors) and,
% Qv - the two points related to the Sampling Points
% xyflag - 1-> is x is Prominant and -2 -> if y is Prominant
% brkpnt - the End Point Index (Selected),
% pntset - Whether this is Samp(1,2)->1, or Samp(4,5)->2.
% This function then returns the sampled points for the Ends of the
% Chromosome.

xvs = xvs';
yvs = yvs';

siz1 = size(xvs,1);

val2chk = Qv(2,xyflag);

if (xyflag==1)
    chvind = find(xvs==val2chk); 
elseif (xyflag==2)
    chvind = find(yvs==val2chk); 
end

xvs = xvs(chvind+1:brkpnt);
yvs = yvs(chvind+1:brkpnt);

brkpnt
chvind
numpnt = brkpnt-chvind

for w=1:numpnt
    xvs(w) = round(xvs(w));
    yvs(w) = round(yvs(w));
end

    if (pntset==1)
        xypnts = [xvs yvs];
        xypnts = flipdim(xypnts,1);
    elseif (pntset==2)
        xypnts = [xvs yvs];
    end
%----------------------------------









