function  [Ordfill]=MyGapFill(PL,gaps)
%Author - AKILA MIKE SUBASINGHE
%This Function Fills in all the Gaps in the Contour, obtained after getting
%the Spline Interpolant Results...

times = size(gaps,1)
Ordfill = [PL(1,1) PL(1,2)];

for r=1:times
    val = gaps(r);
    if (val>3)
        rate = floor(val/2);
        mv = (PL(r+1,2)-PL(r,2))/(PL(r+1,1)-PL(r,1))
        cv = PL(r,2)-(mv*PL(r,1))
        if (abs(mv)<1) %Then x is Dominant
                if (mv<0 && (PL(r+1,2)-PL(r,2))>0)
                    XC = linspace(PL(r,1)-1,PL(r+1,1)+1,rate)
                elseif (mv<0 && (PL(r+1,2)-PL(r,2))<0)
                    XC = linspace(PL(r,1)+1,PL(r+1,1)-1,rate)
                elseif (mv>0 && (PL(r+1,2)-PL(r,2))>0)
                    XC = linspace(PL(r,1)+1,PL(r+1,1)-1,rate)
                elseif (mv>0 && (PL(r+1,2)-PL(r,2))<0)
                    XC = linspace(PL(r,1)-1,PL(r+1,1)+1,rate)
                end               
                YC = mv.*XC + cv
            for e=1:rate
                XC(e) = round(XC(e))
                YC(e) = round(YC(e))
            end
        else %Then y is dominant
                if (mv<0 && (PL(r+1,1)-PL(r,1))>0)
                    YC = linspace(PL(r,2)-1,PL(r+1,2)+1,rate)
                elseif (mv<0 && (PL(r+1,1)-PL(r,1))<0)
                    YC = linspace(PL(r,2)+1,PL(r+1,2)-1,rate)
                elseif (mv>0 && (PL(r+1,1)-PL(r,1))>0)
                    YC = linspace(PL(r,2)+1,PL(r+1,2)-1,rate)
                elseif (mv>0 && (PL(r+1,1)-PL(r,1))<0)
                    YC = linspace(PL(r,2)-1,PL(r+1,2)+1,rate)
                end
            XC = (YC-cv)/mv
            for e=1:rate
                XC(e) = round(XC(e))
                YC(e) = round(YC(e))
            end
        end        
        XC = XC';
        YC = YC';      
        addXY = [XC YC];
        Ordfill = [Ordfill;addXY];               
    end   
     Ordfill = [Ordfill;PL(r+1,1) PL(r+1,2)];   
end
Ordfill = [Ordfill;PL(end,1) PL(end,2)];

