clear all
clc
gridsize = [50 100];
A = zeros(gridsize);
A2 = ones(gridsize); % Used to create a region labeling.. Not directly usable.


    A(40,10:25) = 1; 
    A(39,11:26) = 1;
    A(38,12:27) = 1;
    A(37,13:28) = 1;
    A(36,14:29) = 1;
    A(35,15:30) = 1;
    A(34,16:31) = 1;
    A(33,17:32) = 1;
    A(32,18:33) = 1;
    A(31,19:34) = 1;
    A(30,24:30) = 1;
    A(29,25:31) = 1;
    A(28,22:37) = 1;
    A(27,23:38) = 1;
    A(26,24:39) = 1;
    A(25,25:40) = 1;
    A(24,26:41) = 1;
    A(23,27:42) = 1;
    A(22,28:43) = 1;
    A(21,29:44) = 1;
    A(20,30:45) = 1;
    A(19,31:46) = 1;
    A(18,32:47) = 1;
    A(17,33:48) = 1;
    A(16,34:44) = 1;
    A(15,39:45) = 1;
    A(14,41:51) = 1;
    A(13,37:52) = 1;
    A(12,38:53) = 1;
    A(11,39:54) = 1;
    A(10,40:55) = 1;
    
    
    figure
    imagesc(A);
    %imshow(A,[])
    hold on
    %imagesc(A);
    %colorbar;
    
       
    LblObjBack = bwlabel(A,4);
    RGBObjBack = label2rgb(LblObjBack);
    
    
    B = A;
    
    bt = bwboundaries(B,8);
    boundary = bt{:}
    
    
    xvC = []; yvR = [];
    for i=1:100
      tval = round(-1*i + 57.5);
       % Findout the places where Y is invalid (y>51 and y<1)
      if((tval>0)&&(tval<51))
          xvC = [xvC; i];
          yvR = [yvR; tval];
      end       
    end
    
    
    lineseg = [yvR xvC]
    
    %yv = round(-1*xv + 57.5)
    
    plot(xvC,yvR,'*y')
    hold on
    title ('Basic Setup')
    
   for j=1:length(xvC)
   A2(yvR(j),xvC(j)) = 0;
   end

%    A2(yvR(:),xvC(:)) = 0;
%    figure
%    imshow(A2,[])
    LblLftRgt = bwlabel(A2,4);
    RGBLftRgt = label2rgb(LblLftRgt);
    
%     figure
%     imshow(RGBLftRgt)
%     max(LblLftRgt(:))
    
%   Creating the MASK
    Masking = ~logical(LblObjBack);
%     Masking(LblObjBack==0) = 1;
%     Masking(LblObjBack==1) = 0;

    LblLftRgt = LblLftRgt.* Masking;
    RGBLftRgt2 = label2rgb(LblLftRgt);
%     figure
%     imshow(RGBLftRgt2 ,[])
    
%% Getting the two separate line segments in order....

% First trying to find the two cut points.
boundary(end,:) = []; %Deleting the repetitive entry...
sizeofbound = size(boundary,1)
sizeofline = size(lineseg,1)

% Cut points and there indices (in the boundary) will be stored in the
% following vble names respectively,
% cutpnt, cutpntind
cutpnt = [];
cutpntind = [];

%boundary

for k=1:sizeofline
    %k
    temp = lineseg(k,:);
    temp = repmat(temp,sizeofbound,1);
    subres = abs(boundary - temp);
    subres = sum(subres,2);
    tempind = find(subres==0);
    % Check if this point is a cut point or not.
    if (~isempty(tempind))
        %disp('HURRAH!')
        cutpnt = [cutpnt; boundary(tempind,:)];
        cutpntind = [cutpntind; tempind];
    end    
end

% Checking for the possible number of cut points
if (size(cutpnt,1)~=2)
    h = msgbox('Something s wrong here... STOP!');
end

% Sorting the cutpnts, so that the point higher in the boundary is the
% first...

if (cutpntind(1)>cutpntind(2))
    cutpntind = flipud(cutpntind)
    cutpnt= flipud(cutpnt)
end

% Finding the line segments and storing them in line1, line2

line1 = boundary(cutpntind(1):cutpntind(2),:);
line2 = [boundary(cutpntind(2):sizeofbound,:); boundary(1:cutpntind(1),:)];

line1(1,:) = [];
line1(end,:) = [];
line2(1,:) = [];
line2(end,:) = [];  


plot(line1(:,2),line1(:,1),'w','linewidth',2)
hold on
plot(line2(:,2),line2(:,1),'k','linewidth',2)
hold off

%% Let's try the Hard Part....

% Initially, data will be saved to Mat files and called later.

save('setupresults.mat', 'A', 'LblObjBack', 'LblLftRgt', 'line1', 'line2');
%disp('DONE')


    
    
    
    
    
    
    
    
    
    
    
    
    