function [Ordfill,spnts2] = SplineTempMine2XY(I,SamP,FPathS,pnts)
%Return the Final Ordered Path and the Number of Points of it.

expFlag = 0; %This will be set to '1' if abnormal results appear.

[szRI szCI] = size(I);

PI = zeros(szRI,szCI);
DUM = ones(szRI,szCI);

x = SamP(:,1);
y = SamP(:,2);

firstx = x(1);
lastx = x(end);

firsty = y(1);
lasty = y(end);


x = x';
y = y';


xy = [x;y];

df = diff(xy,1,2);

t = cumsum([0, sqrt([1 1]*(df.*df))]);
cv = csapi(t,xy);

gx = [x(1) x(end)];

hix = max(gx(:))-1;
lox = min(gx(:))+1;

xvals = hix:-1:lox;

yvals = [];

for xv = hix:-1:lox
nyv = round(fnval(fncmb(cv,[0 1]),mean(fnzeros(fncmb(fncmb(cv,[1 0]),'-',xv)))));
yvals = [yvals nyv];

PI(nyv,xv) = 1;

end

yvals;

PI2 = zeros(szRI,szCI);

y1 = x;
x1 = y;

xy1 = [x1;y1];

df1 = diff(xy1,1,2);

t1 = cumsum([0, sqrt([1 1]*(df1.*df1))]);
cv1 = csapi(t1,xy1);

gx1 = [x1(1) x1(end)];

hix1 = max(gx1(:))-1;
lox1 = min(gx1(:))+1;

xvals1 = hix1:-1:lox1;

yvals1 = [];

for xv1 = hix1:-1:lox1
nyv1 = round(fnval(fncmb(cv1,[0 1]),mean(fnzeros(fncmb(fncmb(cv1,[1 0]),'-',xv1)))));
yvals1 = [yvals1 nyv1];

PI(xv1,nyv1) = 1;

end

PI2 = bwmorph(PI,'bridge');
pntPairs = [];

xF = [xvals';yvals1'];
yF = [yvals';xvals1'];

if (size(xF,1)==size(yF,1))
pntPairs = [pntPairs;xF yF];

% figure
% imshow(I,[])
% hold on
% plot(pntPairs(:,1),pntPairs(:,2),'y*','LineWidth',2);
% title('INTERESTIN HA?')
% hold off

    if(size(pntPairs,1)>pnts)
        disp('Ordinary Operation - Splin Points Enough!')

        pntPairs = [pntPairs;x' y'];

        pntPairs = unique(pntPairs, 'rows');

        XYP1 = [firstx firsty];

        [pntPairsOrd gaps] = MyGetContour(pntPairs,firstx,firsty,lastx,lasty);
        spnts1 = size(pntPairsOrd,1);

        [Ordfill]=MyGapFill(pntPairsOrd,gaps);

        spnts2 = size(Ordfill,1);

    else
        disp('Exception Met!')
        %pause;
        [Ordfill] = FPathS;
        spnts2 = size(Ordfill,1);  

    end
    
else
   disp('Exception = Outer Met!')
   %pause;
   [Ordfill] = FPathS;
   spnts2 = size(Ordfill,1);    
end


% figure
% imshow(I,[])
% hold on
% plot(Ordfill(:,1),Ordfill(:,2),'bo','LineWidth',2);
% hold on
% plot(Ordfill(:,1),Ordfill(:,2),'y');






