function [LIR] = calcIndex(LI,m)
%Author -  Akila Mike
%This Function takes in the Linear Indices (LI) and the the # of rows in
%the matrix and returns the (row,col) coordinates back.
sizLI = size(LI,1);
LIR = zeros(sizLI,2);
rows = mod(LI,m);
LIR(:,1) = (m+1)-rows;
cols  = floor(LI./m)+1;
LIR(:,2) = cols;