function [LIR] = calcNormIndex(LI,m)
%Author -  Akila Mike
%This Function takes in the Linear Indices (LI) and the the # of rows in
%the matrix and returns the (row,col) coordinates back.
sizLI = size(LI,1);
LIR = zeros(sizLI,2);
rows = mod(LI,m);
%Correcting for the Special Case...
Ind = find(rows==0);
%Ind2 = find(rows);
rows(Ind) = m;
LIR(:,1) = rows;
cols  = floor(LI./m)+1;
%Correcting for the Special Case...
sizeInd = size(Ind);
if(size(Ind)>0)
    cols(Ind) = (LI./m);
end

LIR(:,2) = cols;



