function [FPath,Flength,bwx,ptel1,ptel2,pside1,pside2,cont,PosSets,DemoFlag,StateFeatureMat] = myBranchFinding2(BW2,I,figflag,number,foldrName)
%Author - AKILA MIKE SUBASINGHE
%After obtaining the Skeleton, it traverse through the Skeletonization 
%result and selects Paths..

B = 1-BW2;
[bwx,I0,xx,yy,x1,y1,aa,bb]=div_skeleton_new(4,1,B,3);


%0000000000000000000000000000000000000000000

[bwxA,I0A,xxA,yyA,x1A,y1A,aaA,bbA]=div_skeleton_new(4,1,B,6);



%pause


% [bwxB,I0B,xxB,yyB,x1B,y1B,aaB,bbB]=div_skeleton_new(4,1,B,5);
% [bwxC,I0C,xxC,yyC,x1C,y1C,aaC,bbC]=div_skeleton_new(4,1,B,6);
% [bwxD,I0D,xxD,yyD,x1D,y1D,aaD,bbD]=div_skeleton_new(4,1,B,7);
% BX = bwboundaries(BW2);
% Z = BX{1};

% figure
% imshow(I,[])
% hold on
% plot(yyA,xxA,'*b','linewidth',3)
% hold on
% plot(y1A,x1A,'*y')
% hold on
% plot(bbA,aaA,'r')
% % hold on
% % plot(Z(:,2),Z(:,1),'y')
% hold off
% title('DCE Result')

tx1A = x1;
ty1A = y1;

%pause
%[ptel1,ptel2,pside1,pside2] = autosegment(aaA,bbA,xxA,yyA,I);



% figure
% imshow(BW2,[])
% title('GVF Result')


% pause
% subplot(2,3,1); imshow(BW2,[])
% title('Original')
% subplot(2,3,2); imshow(bwx,[])
% title('DCE 3')
% subplot(2,3,3); imshow(bwxA,[])
% title('DCE 4')
% subplot(2,3,4); imshow(bwxB,[])
% title('DCE 5')
% subplot(2,3,5); imshow(bwxC,[])
% title('DCE 6')
% subplot(2,3,6); imshow(bwxD,[])
% title('DCE 7')
% 
% % imshow(BWthin,[])
% % title('INTERESTING!!!!')
%0000000000000000000000000000000000000000000


% figure
% imshow(bwx+I0); 
% title('Original with Skeleton')
Xw = y1;
Yw = x1;

bwx = im2bw(bwx);
bwx = myClean(bwx);  %I have written a Function to clean specific Instances.

bwthin = bwmorph(bwx,'thin',Inf);  % MUST DO THIS For My Algo to work.
% figure
% imshow(bwthin,[])
% title('Thinned Image')

pathP1 = [];
pathP2 = [];
pathP3 = [];
offsetP1 = [];
offsetP2 = [];
offsetP3 = [];
%--------------------------------------------------------------------------
%P1 STARTS
i = Xw(1);
j = Yw(1);

%Getting the Start Point after Thinning.....
%First try 3*3 Kernel and so on....
T = bwthin((j-1):(j+1),(i-1):(i+1));
noe = size(find(T),1);

if(noe == 0)
    Q = 1;
    fac = 3;
    while(noe==0)
        fac = fac+2;
        centfac = (fac+1)/2;
        ranfac = centfac-1;
        T = bwthin((j-ranfac):(j+ranfac),(i-ranfac):(i+ranfac));
        noe = size(find(T),1);      
    end
    
    M1 = ones(fac,fac);
    M1(centfac,centfac) = 0;
    Mask = strel(M1);
    RES1 = T .* M1;
    CorLI = find(RES1);
    Cor = calcNormIndex(CorLI,fac);
    offset = Cor - [centfac centfac];
    j = j + offset(1);
    i = i + offset(2);  
else
    M1 = ones(3,3);
    M1(2,2) = 0;
    Mask = strel(M1);
    RES1 = T .* M1;
    CorLI = find(RES1);
    Cor = calcNormIndex(CorLI,3);
    offset = Cor - [2 2];
    j = j + offset(1);
    i = i + offset(2);
    
end

StartP1 = [i j]; %Start Point Calculated....
pathP1 = [pathP1;i j];

%Starts the 1St step of the Cycle
T = bwthin((j-1):(j+1),(i-1):(i+1));
M1 = ones(3,3);
M1(2,2) = 0;
%Mask = strel(M1);
RES1 = T .* M1;
noe = size(find(RES1),1); %Number of Results..STOP When >1
CorLI = find(RES1);
Cor = calcNormIndex(CorLI,3);
whos CorLI
whos Cor
offset = Cor - [2 2];
j = j + offset(1);
i = i + offset(2);

pathP1 = [pathP1;i j];
offsetP1 = [offsetP1;offset(1) offset(2)]; %This Records Movements

%Creating the Next M1......Using RES1
Mask = strel(RES1);
Mask = reflect(Mask);
M1 = getnhood(Mask);
M1 = ~M1;
M1(2,2) = 0; % Done
roundsP1 = 2;

while(1)   
    T = bwthin((j-1):(j+1),(i-1):(i+1));
    RES1 = T .* M1;
    noe = size(find(RES1),1);
    
    if (noe>1)
        break;
    end
    
    CorLI = find(RES1);
    Cor = calcNormIndex(CorLI,3);
    offset = Cor - [2 2];
    j = j + offset(1);
    i = i + offset(2);

    pathP1 = [pathP1;i j];
    offsetP1 = [offsetP1;offset(1) offset(2)]; %This Records Movements
    
    Mask = strel(RES1);
    Mask = reflect(Mask);
    M1 = getnhood(Mask);
    M1 = ~M1;
    M1(2,2) = 0; % Done    
    roundsP1 = roundsP1+1;
end
roundsP1;
pathP1;
%P1 ENDS
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
%P2 STARTS
i = Xw(2);
j = Yw(2);

%Getting the Start Point after Thinning.....
%First try 3*3 Kernel....
T = bwthin((j-1):(j+1),(i-1):(i+1));
noe = size(find(T),1);

if(noe == 0)
    Q = 1;
    fac = 3;
    while(noe==0)
        fac = fac+2;
        centfac = (fac+1)/2;
        ranfac = centfac-1;
        T = bwthin((j-ranfac):(j+ranfac),(i-ranfac):(i+ranfac));
        noe = size(find(T),1);      
    end
    
    M1 = ones(fac,fac);
    M1(centfac,centfac) = 0;
    Mask = strel(M1);
    RES1 = T .* M1;
    CorLI = find(RES1);
    Cor = calcNormIndex(CorLI,fac);
    offset = Cor - [centfac centfac];
    j = j + offset(1);
    i = i + offset(2);    
else
    M1 = ones(3,3);
    M1(2,2) = 0;
    Mask = strel(M1);
    RES1 = T .* M1;
    CorLI = find(RES1);
    Cor = calcNormIndex(CorLI,3);
    offset = Cor - [2 2];
    j = j + offset(1);
    i = i + offset(2);    
end

StartP2 = [i j]; %Start Point Calculated....
pathP2 = [pathP2;i j];

%Starts the 1St step of the Cycle
T = bwthin((j-1):(j+1),(i-1):(i+1));
M1 = ones(3,3);
M1(2,2) = 0;
RES1 = T .* M1;
noe = size(find(RES1),1); %Number of Results..STOP When >1
CorLI = find(RES1);
Cor = calcNormIndex(CorLI,3);
whos CorLI
whos Cor
offset = Cor - [2 2];
j = j + offset(1);
i = i + offset(2);

pathP2 = [pathP2;i j];
offsetP2 = [offsetP2;offset(1) offset(2)]; %This Records Movements

%Creating the Next M1......Using RES1
Mask = strel(RES1);
Mask = reflect(Mask);
M1 = getnhood(Mask);
M1 = ~M1;
M1(2,2) = 0; % Done
roundsP2 = 2;

while(1)
    T = bwthin((j-1):(j+1),(i-1):(i+1));
    RES1 = T .* M1;
    noe = size(find(RES1),1);
    
    if (noe>1)
        break;
    end
    
    CorLI = find(RES1);
    Cor = calcNormIndex(CorLI,3);
    offset = Cor - [2 2];
    j = j + offset(1);
    i = i + offset(2);

    pathP2 = [pathP2;i j];
    offsetP2 = [offsetP2;offset(1) offset(2)]; %This Records Movements
    
    Mask = strel(RES1);
    Mask = reflect(Mask);
    M1 = getnhood(Mask);
    M1 = ~M1;
    M1(2,2) = 0; % Done    
    roundsP2 = roundsP2+1;   
end

roundsP2;
pathP2;
%P2 ENDS
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
%P3 STARTS
i = Xw(3);
j = Yw(3);

%Getting the Start Point after Thinning.....
%First try 3*3 Kernel....
T = bwthin((j-1):(j+1),(i-1):(i+1));
noe = size(find(T),1);

if(noe == 0)
    Q = 1;
    fac = 3;
    while(noe==0)
        fac = fac+2;
        centfac = (fac+1)/2;
        ranfac = centfac-1;
        T = bwthin((j-ranfac):(j+ranfac),(i-ranfac):(i+ranfac));
        noe = size(find(T),1);      
    end
    
    M1 = ones(fac,fac);
    M1(centfac,centfac) = 0;
    Mask = strel(M1);
    RES1 = T .* M1;
    CorLI = find(RES1);
    Cor = calcNormIndex(CorLI,fac);
    offset = Cor - [centfac centfac];
    j = j + offset(1);
    i = i + offset(2);    
else
    M1 = ones(3,3);
    M1(2,2) = 0;
    Mask = strel(M1);
    RES1 = T .* M1;
    CorLI = find(RES1);
    Cor = calcNormIndex(CorLI,3);
    offset = Cor - [2 2];
    j = j + offset(1);
    i = i + offset(2);
    
end

StartP3 = [i j]; %Start Point Calculated....
pathP3 = [pathP3;i j];

%Starts the 1St step of the Cycle
T = bwthin((j-1):(j+1),(i-1):(i+1));
M1 = ones(3,3);
M1(2,2) = 0;
RES1 = T .* M1;
noe = size(find(RES1),1); %Number of Results..STOP When >1
CorLI = find(RES1);
Cor = calcNormIndex(CorLI,3);
whos CorLI
whos Cor
offset = Cor - [2 2];
j = j + offset(1);
i = i + offset(2);

pathP3 = [pathP3;i j];
offsetP3 = [offsetP3;offset(1) offset(2)]; %This Records Movements

%Creating the Next M1......Using RES1
Mask = strel(RES1);
Mask = reflect(Mask);
M1 = getnhood(Mask);
M1 = ~M1;
M1(2,2) = 0; % Done
roundsP3 = 2;

while(1) 
    T = bwthin((j-1):(j+1),(i-1):(i+1));
    RES1 = T .* M1;
    noe = size(find(RES1),1);
    
    if (noe>1)
        break;
    end
    
    CorLI = find(RES1);
    Cor = calcNormIndex(CorLI,3);
    offset = Cor - [2 2];
    j = j + offset(1);
    i = i + offset(2);

    pathP3 = [pathP3;i j];
    offsetP3 = [offsetP3;offset(1) offset(2)]; %This Records Movements
    
    Mask = strel(RES1);
    Mask = reflect(Mask);
    M1 = getnhood(Mask);
    M1 = ~M1;
    M1(2,2) = 0; % Done   
    roundsP3 = roundsP3+1;   
end

roundsP3;
pathP3;
%P3 ENDS
%--------------------------------------------------------------------------
minpath = 1;
minP = roundsP1;

if (roundsP2<minP)
    %disp('SECOND PATH REMOVED')
    minP = roundsP2;
    minpath=2;
end

if (roundsP3<minP)
    %disp('THIRD PATH REMOVED')
    minP = roundsP3;
    minpath=3;
end



%New Part added for AUTOSEGMENT -
%disp('After Removing')
tx1A(minpath) = [];
ty1A(minpath) = [];


PntPos = 'PointSet_';
numb1 = int2str(number);
Formati = '.tif';
Pimgn = [foldrName PntPos numb1 Formati];



%labels = cellstr(num2str([1:6]'));  %' # labels correspond to their order
%labels = num2str(1:6);
labels =num2str([1:6]');

figure
%imshow(bwxA,[])
imagesc(bwxA)
hold on
plot(y1A,x1A,'sb','linewidth',3);
%hold on
plot(bbA,aaA,'.w','linewidth',2);
%hold on
  plot(yyA(1),xxA(1),'*y','linewidth',6); 
  %hold on
  text(yyA(1),xxA(1), 'Point 1','VerticalAlignment','bottom','HorizontalAlignment','right', 'FontSize',12,'Color',[0 0 1]);
  %hold on
  plot(yyA(2),xxA(2),'*y','linewidth',6); 
  %hold on
  text(yyA(2),xxA(2), 'Point 2','VerticalAlignment','bottom','HorizontalAlignment','right', 'FontSize',12,'Color',[0 0 1]);
  %hold on
  plot(yyA(3),xxA(3),'*y','linewidth',6); 
  %hold on
  text(yyA(3),xxA(3), 'Point 3','VerticalAlignment','bottom','HorizontalAlignment','right', 'FontSize',12,'Color',[0 0 1]);
  %hold on
  plot(yyA(4),xxA(4),'*y','linewidth',6); 
  %hold on
  text(yyA(4),xxA(4), 'Point 4','VerticalAlignment','bottom','HorizontalAlignment','right', 'FontSize',12,'Color',[0 0 1]);
  %hold on
  plot(yyA(5),xxA(5),'*y','linewidth',6); 
  %hold on
  text(yyA(5),xxA(5), 'Point 5','VerticalAlignment','bottom','HorizontalAlignment','right', 'FontSize',12,'Color',[0 0 1]);
  %hold on
  plot(yyA(6),xxA(6),'*y','linewidth',6); 
  %hold on
  text(yyA(6),xxA(6), 'Point 6','VerticalAlignment','bottom','HorizontalAlignment','right', 'FontSize',12,'Color',[0 0 1]);
%hold on
plot(ty1A(1),tx1A(1),'*r','linewidth',5);
%hold on
plot(ty1A(2),tx1A(2),'*r','linewidth',5);
%hold on
hold off
title('Salient Point List');
colormap(hot(256))
%print -f1 -dtiff 'Figure1.tif'
print('-f1', '-dtiff', [foldrName PntPos numb1 Formati])
%saveas(gcf,Pimgn,'tif')

pause


[ptel1,ptel2,pside1,pside2,cont,PosSets,DemoFlag,StateFeatureMat] = autosegmentNEW2(aaA,bbA,xxA,yyA,I,tx1A,ty1A,figflag,x1A,y1A,number,foldrName);

%pause

%-------------------------------------------------------------------
%CREATING THE RESULTING PATH VECTOR ACCORDING TO WHAT IS REMOVED....
FPath = [];
Flength = 0;
if(minpath==1)  %Shortest - Path1.
    Flength = roundsP2+roundsP3;
    Rpath = myReverse(pathP3);
    FPath = [pathP2;Rpath];
elseif(minpath==2)%Shortest - Path2.
    Flength = roundsP1+roundsP3;
    Rpath = myReverse(pathP3);
    FPath = [pathP1;Rpath] ;  
else              %Shortest - Path3. 
    Flength = roundsP1+roundsP2;
    Rpath = myReverse(pathP2);
    FPath = [pathP1;Rpath];     
end    
%-------------------------------------------------------------------

bw2thin = bwthin;
if (minpath == 1)
    dRv = pathP1(:,2);
    dCv = pathP1(:,1);
      
    for e=1:roundsP1
    bw2thin(dRv(e),dCv(e))=0;  
    end
end

if (minpath == 2)
    dRv = pathP2(:,2);
    dCv = pathP2(:,1);
      
    for e=1:roundsP2
    bw2thin(dRv(e),dCv(e))=0;  
    end
end

if (minpath == 3)
    dRv = pathP3(:,2);
    dCv = pathP3(:,1);
      
    for e=1:roundsP3
    bw2thin(dRv(e),dCv(e))=0;  
    end
end

%     figure
%     imshow(bw2thin)
%     title('Prunned Image')   
%------------------------------------------------------------------
