function [CI,Ratio1] = myCalculations(Path,ImgScale)
%Author - AKILA MIKE
%This Function Takes the Tarced Medial Axis "Path" and the Image Pixel Size
%"ImgScale" (in nms), and then computes the Eucledian Length of the
%Chromosome "EUL" in nms.

sizeL = size(Path);
EUL = 0;

for t=1:sizeL-1
   npx = Path(t,1);
   npy = Path(t,2);
   npx2 = Path(t+1,1);
   npy2 = Path(t+1,2);
   
   difsum = abs(npx - npx2)+ abs(npy - npy2);
      if(difsum>1)
        EUL = EUL+sqrt(2); 
      else
        EUL = EUL+1;
      end
end

EUL = EUL * ImgScale;