function [SelectAng] = myCumCurvValue2(AngleSet,indexP,len)
%This should calculate the curvature values (Cumulative) for a contour at
%an index point. The region of consideration is empirically set with
%percFac. totalP gives the total number of points considered. 
indexP;
TotL = size(AngleSet,1);
leftAngle = 0;
rightAngle = 0;

% if (len<60)
%     percFac = floor(len/12)
% else
%     percFac = 6
% end

if (len<30)
    percFac = 2;
else
    percFac = 3;
end
%percFac = 2

%indexP

%disp('Left hand side')
if((indexP-percFac)<1) %Can result in an error
    %disp('Can result in an error')
    temp = AngleSet(indexP)- AngleSet(1);
    leftAngle = AngleSet(end) - AngleSet(TotL-indexP);
    leftAngle = (leftAngle+temp)/percFac;
else
    %disp('Straight forward')
    leftAngle = (AngleSet(indexP) - AngleSet(indexP-percFac))/percFac;
end

%disp('Right hand side')
if((indexP+percFac)>TotL) %Can result in an error
    %disp('Can result in an error')
    temp = AngleSet(TotL)- AngleSet(indexP);
    rightAngle = AngleSet(percFac-(TotL-indexP)) - AngleSet(1);
    rightAngle = (rightAngle + temp)/percFac;
else
    %disp('Straight forward')
    rightAngle = (AngleSet(indexP+percFac) - AngleSet(indexP))/percFac;
end

SelectAng = leftAngle+rightAngle;

%pause

end