function [AngleSet,sumv] = myCurvefindingNEW(aa,bb,I)

%x - aa, y - bb. But when plotting, (bb,aa)

%Currently working for only 3 input cordinates & Getting the inner angle.

% %FIRST METHOD - Using EUCLEDIAN LENGHTS
% 
% % (aa) - [P2;P1;P3]
% clc
% aa = [3;1;2];
% bb = [7;7;9];
% 
% P12 = sqrt((aa(2)-aa(1)).^2 + (bb(2)-bb(1)).^2);
% P13 = sqrt((aa(3)-aa(2)).^2 + (bb(3)-bb(2)).^2);
% P23 = sqrt((aa(1)-aa(3)).^2 + (bb(1)-bb(3)).^2);
% 
% Core1 = (P12^2 + P13^2 - P23^2)/(2*P12*P13);
% Angle = acos((P12^2 + P13^2 - P23^2)/(2*P12*P13)) * (180/pi)
% 
% % Works, But doesn't give - ve values .... MUCH BETTER THAN VECTOR MODEL
% 
% %SECOND METHOD - Using VECOTRS
% disp('****************************************************')
% 
% p12 = [(aa(2)-aa(1)) (bb(2)-bb(1))];
% p32 = [(aa(3)-aa(2)) (bb(3)-bb(2))];
% 
% Absp12 = sqrt(sum(p12.^2))
% Absp32 = sqrt(sum(p32.^2))
% 
% Core2 = (sum(p12.*p32)/(Absp12*Absp32));
% Theta = acos(sum(p12.*p32)/(Absp12*Absp32)) * (180/pi)
% 
% % Works, But doesn't give - ve values ....

disp('****************************************************')
disp('****************************************************')

%aa = aa';
%bb = bb';

% whos aa
% whos bb

% %Some Sampling to reduce noise
% szv = size(aa,1)
% indset = zeros(szv,1);
% gap = 3;
% 
% indgap = 1:gap:szv;
% indgap = indgap';
% 
% indset(indgap) = 1;
% 
% aa = aa(logical(indset));
% bb = bb(logical(indset));



% whos aa
% whos bb



% aa = [10;6;3;3;1;6;9;8];
% bb = [10;10;7;5;3;2;4;6];

% aa = [10;8;9;6;1;3;3;6];
% bb = [10;6;4;2;3;5;7;10];

% aa = [3;1;1]
% bb = [7;7;4]

p12 = [(circshift(aa,[1 0])-aa) (circshift(bb,[1 0])-bb)];
p32 = [(circshift(aa,[-1 0])-aa) (circshift(bb,[-1 0])-bb)];

Theta2 = (atan2(p12(:,1),p12(:,2)) - atan2(p32(:,1),p32(:,2))) * (180/pi);

% P12 = sqrt((aa(2)-aa(1)).^2 + (bb(2)-bb(1)).^2);
% P13 = sqrt((aa(3)-aa(2)).^2 + (bb(3)-bb(2)).^2);
% P23 = sqrt((aa(1)-aa(3)).^2 + (bb(1)-bb(3)).^2);

% Core1 = (P12.^2 + P13.^2 - P23.^2)./(2.*P12.*P13)

Ang = Theta2;

ind1 = (Theta2>180);
Theta2(ind1) = Theta2(ind1) - 360;

% if (Theta2>180)
%     Theta2 = Theta2 - 360;
% end
% 

ind2 = (Theta2<0);
ind3 = (Theta2>=0);
Ang(ind2) = -180 - Theta2(ind2);
Ang(ind3) = 180 - Theta2(ind3);

sumv = sum(Ang)

if (round(sumv) == -360)
    disp('NEGATIVE HERE!!!')
    Ang = -1.*Ang;
    sumv = -1.* sumv;
end

%pause
% if (Theta2 < 0)
%     Ang = -180 + Theta2;
% else
%     Ang = 180 - Theta2;
% end

cumAng = cumsum(Ang);

szN = size(aa,1) %Used to plot the numbered image -  for understanding.
numList = 1:szN;
numList = numList';
numL = num2str(numList);

%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

% figure
% imshow(I,[])
% hold on
% plot(bb,aa,'b','linewidth',2)
% hold on
% plot([bb(end) bb(1)],[aa(end) aa(1)],'b','linewidth',2)
% hold on
% text(bb,aa,numL,'FontSize',12) 
% title('Object Shape')
% hold off

%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^







% figure
% plot(cumAng,'--rs','LineWidth',2,...
%                 'MarkerEdgeColor','k',...
%                 'MarkerFaceColor','g',...
%                 'MarkerSize',10)
% grid on
% grid minor
% title('Cumulative Angle Values')
% 
% 
% figure
% plot(Ang,'--bs','LineWidth',2,...
%                 'MarkerEdgeColor','k',...
%                 'MarkerFaceColor','y',...
%                 'MarkerSize',10)
% grid on
% grid minor
% title('Angle Values')

save('ANGLEVALS.mat','cumAng', 'Ang','I','aa','bb')

AngleSet = cumAng;


%)))))))

% figure
% plot(cumAng,'--rs','LineWidth',2,...
%                 'MarkerEdgeColor','k',...
%                 'MarkerFaceColor','g',...
%                 'MarkerSize',10)
% hold on
% plot(Ang,'--bs','LineWidth',2,...
%                 'MarkerEdgeColor','k',...
%                 'MarkerFaceColor','y',...
%                 'MarkerSize',10)
% grid on
% grid minor
% hold off
% title('Cumulative Angle Values')

%---------

%TRYING THE STEP TO FINDING CONVEX REGIONS.... 

%Getting the step-wise difference...




%pause

