function [EUL] = myEuclLengthNEW2(ind1,ind2,cont)
%Author - AKILA MIKE
%This function takes in two indices and then calculate the Euc dis along
%the contour 'cont'.
%Updated to ONLY RETURN THE STRAIGHT FORWARD EUC LENGTH


EUL1 = 0;
EUL2 = 0;
szCont = size(cont,1);

if (ind1<ind2)
   Path1 = cont(ind1:ind2,:); 
else
   Path1 = cont(ind1:szCont,:);
   Path1 = [Path1;cont(1:ind2,:)];
end

lineS1 = Path1;
lineST1 = circshift(lineS1,-1);
diffV1 = lineST1 - lineS1;
diffV1(end,:) = [];
diffVSq1 = diffV1.*diffV1;
diffVal1 = sqrt(sum(diffVSq1,2));
EUL1 = sum(diffVal1);

EUL = EUL1;

% temp = ind1;
% ind1 = ind2;
% ind2 = temp;
% 
% if (ind1<ind2)
%    Path2 = cont(ind1:ind2,:); 
% else
%    Path2 = cont(ind1:szCont,:);
%    Path2 = [Path2;cont(1:ind2,:)];
% end
% 
% lineS2 = Path2;
% lineST2 = circshift(lineS2,-1);
% diffV2 = lineST2 - lineS2;
% diffV2(end,:) = [];
% diffVSq2 = diffV2.*diffV2;
% diffVal2 = sqrt(sum(diffVSq2,2));
% EUL2 = sum(diffVal2)
% 
% 
% if(EUL1<=EUL2)
%     EUL = EUL1;
% else
%     EUL = EUL2;
% end
