function  [BWN]=myLabelObjExtract(COMB,BWT,corC,corR)
%Author - AKILA MIKE SUBASINGHE
%For Finding the nearest Binary Object when the Probe is at the Furthest
%end of the chromosome.

INF = tan(pi/2);
L = bwlabel(BWT,4);
Fmindist = INF;
FminLbl = 0;

[szLR szLC]= size(BWT);
BWN = zeros(szLR,szLC);


maxn = max(L(:));

for t=1:maxn
    
    [r c] = find(L==t);
    RC = [r c];
    Cor =[corC corR];
    sizrc = size(RC,1);
    repCor = repmat(Cor,sizrc,1);
%     whos RC
%     whos repCor
    RCdif = abs(RC-repCor);
    RCdlist = sum(RCdif,2);
    minv = min(RCdlist);
    %minind = find(RCdlist == minv);
    
    if (minv<Fmindist)
        disp('CAME INSIDE WITH!!!!!')
        Fmindist = minv;
        FminLbl  = t;       
    end
      
end


IND = find(L==FminLbl);
BWN(IND) = 1;


