function  [Findex,Fpair] = myPointProject(OrdL,corX,corY,I)
%Author - AKILA MIKE SUBASINGHE
%Date modified - 5th Jan 2010.
%This function when provided with the Ordered Medial Axis (Complete) alone
%with the X and Y coordinates of the Probe Location, it returns the Index
%and the X,Y coordinates of the corresponding 

Cpnt = 0;
Cind = 0;

Cpnt2 = 0;
Cind2 = 0;

Findex = 0;
Fpair = [];

%disp('First and Last of the Centerline')
OrdL(1,:);
OrdL(end,:);

%disp('Clicked Point is')
%[corX,corY]

sizeL = size(OrdL,1);

[szIR szIC] = size(I);

xvC = OrdL(:,1);
yvC = OrdL(:,2);

% figure
% imshow(I,[])
% hold on
% plot(OrdL(:,1),OrdL(:,2),'w.','LineWidth',1);
% hold on
% plot(corX,corY,'yo','LineWidth',2)
% hold on 

flagv = 1;
espflag = 0;
m = 1;
rounds = 0;
%1:sizeL-2
while (flagv)
%m = m + 1;   
rounds = rounds + 1;
    stp = m;
    thp = stp+1;
    stp2 = stp+2;  
   
    if((xvC(stp2)-xvC(stp))==0)
        mo = 57;
        m1 = 0;
    elseif ((yvC(stp2)-yvC(stp))==0)
        mo = 0;
        m1 = 57;
    else
        mo = (yvC(stp2)-yvC(stp))/(xvC(stp2)-xvC(stp));
        m1 = -1/mo;
    end
    
    c = yvC(thp) - (mo*xvC(thp));
    c1 = corY - (m1*corX);
    
    nX = (c-c1)/(m1-mo);
    nY = m1*nX + c1;

    gap = floor(sqrt((nX-xvC(thp))^2+(nY-yvC(thp))^2));
    Cpnt = gap;
    
    if ((m + round(gap/2))<sizeL)
        m = m + round(gap/2);
        Cind = m;
    else
        espflag = 1;
    end

%     plot(xvC(thp),yvC(thp),'b*','LineWidth',2)
%     hold on  
%    
%     plot(nX,nY,'r+','LineWidth',2)
%     hold on

        if((gap<1) || (espflag==1))    
        flagv = 0;
        end
end

% % plot(nX,nY,'m*','LineWidth',2)
% % hold on

%Nearest Neighbor Method...For clarification.
rCor = [corX corY];
repCor = repmat(rCor,sizeL,1);

ndif = abs(OrdL-repCor);
diflist = sum(ndif,2);
%valueofinterest = diflist(Cind)
minv = min(diflist);
minind = find(diflist == minv);
minindS = size(minind,1);

if(minindS>1)
    midind = minind(floor(minindS/2));
else
    midind = minind;
end

diffval = abs(Cind - midind);

%++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
if (diffval>2)

disp('=====================')
disp('SPECIAL CONDITION----')
disp('=====================')

OrdL2 = OrdL;
OrdL2 = flipdim(OrdL2,1);
xvC2 = OrdL2(:,1);
yvC2 = OrdL2(:,2);


flagv2 = 1;
espflag2 = 0;
m2 = 1;
rounds2 = 0;
%1:sizeL-2
    while (flagv2)
    %m = m + 1;   
        rounds2 = rounds2 + 1;
        stp = m2;
        thp = stp+1;
        stp2 = stp+2;  

        if((xvC2(stp2)-xvC2(stp))==0)
            mo = 57;
            m1 = 0;
        elseif ((yvC2(stp2)-yvC2(stp))==0)
            mo = 0;
            m1 = 57;
        else
            mo = (yvC2(stp2)-yvC2(stp))/(xvC2(stp2)-xvC2(stp));
            m1 = -1/mo;
        end

        c = yvC2(thp) - (mo*xvC2(thp));
        c1 = corY - (m1*corX);

        nX2 = (c-c1)/(m1-mo);
        nY2 = m1*nX2 + c1;

        gap2 = floor(sqrt((nX2-xvC2(thp))^2+(nY2-yvC2(thp))^2));
        Cpnt2 = gap2;

        if ((m2 + round(gap2/2))<sizeL)
            m2 = m2 + round(gap2/2);
            Cind2 = m2;
        else
            espflag2 = 1;
        end

%         plot(xvC2(thp),yvC2(thp),'bs','LineWidth',2)
%         hold on  
%
%         plot(nX2,nY2,'rd','LineWidth',2)
%         hold on

            if((gap2<1) || (espflag2==1))    
            flagv2 = 0;
            end
    end
         
% % plot(nX2,nY2,'c*','LineWidth',3)
% % hold on

Cind2 = sizeL - Cind2;
diffval2 = abs(Cind2 - midind);
    
else
diffval2 = sizeL;   
end

mindif  = min(diffval,diffval2);

selnumb = 0;

if(mindif<5)
    if(diffval <= diffval2)
        Findex = Cind+1;
        selnumb = 1;
        disp('Selected Set 1! *********')
    else
        Findex = Cind2;
        selnumb = 2;
        disp('Selected Set 2! *********')
    end
    
else   
    Findex = midind;
    selnumb = 3;
    disp('Selected Set 3! *********')   
end

Fpair = [Fpair;xvC(Findex) yvC(Findex)];


% plot(xvC(Findex),yvC(Findex),'g*','LineWidth',6)
% hold off







