function [ANew] = mycleannuclei(AOld,imagetype)
%Author - Akila Subasinghe
%Date 04/Dec/2012
%Purpose - given an image, to simply remove large blobs and nuclei from it.
%Kept the process simple for now (pixel based thresholding. Will explore
%more later on. 
ACopy = AOld;

if (imagetype==1)
ACopy = 255 - ACopy;    %WHEN THE IMAGES ARE INVERTED IMAGES.
end


ACopy = imadjust(ACopy);
basel = graythresh(ACopy);
BWCopy = im2bw(ACopy, basel);
BWCopy = bwmorph(BWCopy,'clean');
% figure, imshow(BWCopy,[]) 
% title('BINARY IMAGE')

[rsz,csz] = size(ACopy);
avgInt = sum(ACopy(:))/(rsz*csz)

total = bwarea(BWCopy)

L = bwlabel(BWCopy, 4);
DataS = regionprops(L, 'Area')

Areanum = [DataS.Area];
Areanum = Areanum';
sz = size(Areanum,1)

whos Areanum
Areanum

%Calc and Removing larger objects
threshv = ceil(total/(sz/3.5))

Labelind = find(Areanum>threshv)
numofnuc = size(Labelind,1)

Nucleiind = [];

%for i=1:numofnuc
for i=1:numofnuc
   Tind = find(L==(Labelind(i)));
   %whos Tind
   Nucleiind = [Nucleiind;Tind];
end

ACopy(Nucleiind) = avgInt;

% figure
% imshow(ACopy,[])
% title('All down')


if (imagetype==1)
ACopy = 255 - ACopy;    %WHEN THE IMAGES ARE INVERTED IMAGES.
end

ANew = ACopy;


%AT = bwselect(BWT,halfsizeR,halfsizeC,4);