function [BW2,contourPxy] = CentreofOPS2(I,AT)
%Author - AKILA MIKE
%This Tries to Get Data Fitting By Skeletons..

[sizR sizC] = size(I);

[x,y] = gvfsnakeEvolve(I,AT);

xSp = x;
ySp = y;

contourPxy = [x y];

% figure
% plot(x,y,'*b')
% saveas(gcf,'X_Y_Points.tif')

savefile = 'DataS.mat';
save(savefile, 'x', 'y')

BW2 = poly2mask(x, y, sizR, sizC);
imwrite(BW2,'Masking.tif');

Temp1 = I;
RES1 = Temp1 .* BW2;
imwrite(RES1,'Extract.tif');

LI = find(BW2);
LIM = calcNormIndex(LI,sizR);
xT = LIM(:,2);
yT = LIM(:,1);

BWX = bwmorph(BW2,'thin',Inf);

LIT = find(BWX);
LIMT = calcNormIndex(LIT,sizR);
xSk = LIMT(:,2);
ySk = LIMT(:,1);
