function [Ordfill, xv, yv, xvp, yvp] = Col7(I,SamP,OrdfillInt,x1,y1,x2,y2,ptel1,ptel2,maxsize,figflag)
%Author - AKILA MIKE SUBASINGHE
%Performs Sampling along the Corrected End Points and Adds the Resulting
%Path segments to the Medial Axis...and Display.

fname = 'FinalPath.mat';
load MASK4

Ia = I;
% FOR THE MASK ----------------------------------------------------------
%Ia = padarray(Ia,[padFac padFac],255);  % PADDING DONE HERE....
% FOR THE MASK ----------------------------------------------------------
I2 = 255 - Ia;

[yRsize, xCsize] = size(I);

% FOR THE MASK ----------------------------------------------------------
%cent = 11;  %DO NOT CHANGE - MASK SPECIFIC VALUES
%sz = 20;    %DO NOT CHANGE - MASK SPECIFIC VALUES 
% FOR THE MASK ----------------------------------------------------------

xyflag = 0; %This been '1' - x is Prominant (|m|<1),'2' - y is Prominant
xyflagp = 0;

% FOR THE MASK ----------------------------------------------------------
%SamP = SamP + padFac;
% FOR THE MASK ----------------------------------------------------------

load SVMModelC2

ptel1 = flipdim(ptel1,2);
ptel2 = flipdim(ptel2,2);

flagTel1 = 0;       % Flag that makes the program correct for sister Chromatid separation.
flagTel2 = 0;
EndReverse = 0;     % Flag to indicate if the ends and telomere numbers don't correspond.

End1 = SamP(1,:);
End2 = SamP(end,:);

sizetel1 = size(ptel1,1);
sizetel2 = size(ptel2,1);

RepEnd1 = repmat(End1,sizetel1,1);
RepEnd2 = repmat(End2,sizetel1,1);

End1diff = abs(RepEnd1 - ptel1);
End1diff = End1diff.^2;
End1diff = sqrt(sum(End1diff,2));
MinEnd1diff = min(End1diff);
End2diff = abs(RepEnd2 - ptel1);
End2diff = End2diff.^2;
End2diff = sqrt(sum(End2diff,2));
MinEnd2diff = min(End2diff);


if (MinEnd1diff<=MinEnd2diff)
    disp('Normal way')
    %Getting the mid point of Telomere 1 for end 1.     
else
    %disp('End #2(top) is closer to Telomere #1')
%     tempind = round(sizetel2/2)
%     End1PntT = ptel2(tempind,:)
%     End1data = [x2, y2];
    
    disp('Reverse Flag (FlagReverse) is set to 1!!!')
    
%     tempind = round(sizetel1/2)
%     End2PntT = ptel1(tempind,:)
%     End2data = [x1, y1];
    
    EndReverse = 1;
end

disp('LOOK FROM HERE UNDER ++++++++++++++++++++++++++')
sizetel1 = size(ptel1,1);
sizetel2 = size(ptel2,1);

    tempind1 = round(sizetel1/2);
    ptel1;
    Tel1PntT = ptel1(tempind1,:);
    Tel1data = [x1, y1];
    
    tempind2 = round(sizetel2/2);
    ptel2;
    Tel2PntT = ptel2(tempind2,:);
    Tel2data = [x2, y2];


    %disp('Trying out Telomere 1 - Separation Present or not')
    classTel1 = svmclassify(svmStruct,Tel1data);
    
    %disp('Trying out Telomere 2 - Separation Present or not')
    classTel2 = svmclassify(svmStruct,Tel2data);

    
    %% COMMENT THIS PART TO REMOVE THE CORRECTION FOR END POINT
    if (classTel1==1)
        disp('Flag set at telomere 1 - There s a wiggle')
        flagTel1 = 1;
    end
    if (classTel2==1)
        disp('Flag set at telomere 2 - There s a wiggle')
        flagTel2 = 1;
    end
    %%%%%%% COMMENT THIS PART TO REMOVE THE CORRECTION FOR END POINT
    %%

% FOR END #1 ONLY 
disp('FOR END #1 ONLY')
    if (EndReverse==0)  %Normal way - End1 <-> Telo1
        disp('Normal way - End1 <-> Telo1')
        if (flagTel1==1)%There is a WIGGLE At Tel1 for End1
            disp('There is a WIGGLE At Tel1 for End1')
            Q1 = [Tel1PntT;SamP(2,:)];
        else            %There is NO WIGGLE - USUAL
            disp('There is NO WIGGLE - USUAL')
            Q1 = SamP(1:2,:);         
        end
        
    else                %Changed - End1 <-> Telo2
        disp('Changed - End1 <-> Telo2')
        if (flagTel2==1)%There is a WIGGLE At Tel2 for End1
            disp('There is a WIGGLE At Tel2 for End1')
            Q1 = [Tel2PntT;SamP(2,:)];
        else            %There is NO WIGGLE - USUAL
            disp('%There is NO WIGGLE - USUAL')
            Q1 = SamP(1:2,:);        
        end
        
    end
    
    



% whos End1
% whos sizetel1
% whos RepEnd1
% whos RepEnd2


%pause

% BELOW PART SHOULD BE ONLY IF THERE S NO WIGGLE FROM THE SVM ANALYSIS!!!
%______________________________________________________________________
% if(flagEnd1==1)
%     if (EndReverse==0)
%         Q1 = [End1PntT;SamP(1,:)];
%     else
%         Q1 = [End2PntT;SamP(1,:)];
%     end
% else
%     Q1 = SamP(1:2,:);
% end
%______________________________________________________________________

Q1 = flipdim(Q1,1);

Qdif = Q1(1,1)-Q1(2,1);

m = (Q1(2,2)-Q1(1,2))/(Q1(2,1)-Q1(1,1));

if(m==Inf || m==-Inf)
    m = 57;
end

% if(m==Inf)
%     m = 57
% end
% 
% if(m==-Inf)
%     m = -57
% end

c = (Q1(1,2))-(m*Q1(1,1));

% FOR THE MASK ----------------------------------------------------------
% if (m>0)
%     angR = atan(m);
%     ang = -90 -1*(180*angR)/pi;
% else
%     %T = 180 -(1*(180*angR)/pi) 
%     %ang = -90 -T  
%     m1 = -1/m;
%     angR = atan(m1);
%     ang = -180 -1*(180*angR)/pi;    
% end
%J = imrotate(Mask,ang,'crop');  %Keeps the Size Constant
% FOR THE MASK ----------------------------------------------------------

% yRsize
% xCsize

%pause

%Flag set to know which Direction to Go to...1 = Left, 2 = Right
%Selection of xy Direction
if (m>=0) %with Positive m values  
    if(Qdif < 0)
        if (abs(m)<=1)
            % FOR THE MASK -----------------------------------------------
            %xv = (Q1(1,1)):1:(Q1(1,1)+smpWidth); 
            % FOR THE MASK -----------------------------------------------
            xv = (Q1(1,1)):1:xCsize;
            yv = m*(xv) + c;
            
            Tind = logical((yv>maxsize)+(yv<1));
            yv(Tind) = [];
            xv(Tind) = [];
%             Tind = (yv>yRsize);
%             xv(Tind) = [];
%             yv(Tind) = [];
            xyflag = 1;
        else
            % FOR THE MASK -----------------------------------------------
            %yv = (Q1(1,2)):1:(Q1(1,2)+smpWidth);
            % FOR THE MASK -----------------------------------------------
            yv = (Q1(1,2)):1:yRsize;
            xv  = (yv-c)/m;
            
            Tind = logical((xv>maxsize)+(xv<1));
            xv(Tind) = [];
            yv(Tind) = [];
%             Tind = (xv>xCsize);
%             xv(Tind) = [];
%             yv(Tind) = [];
            xyflag = 2;
        end           
    flag = 1;    %Have + M & Coming further Down with MASK (MASK right)
    elseif(Qdif > 0)
        if (abs(m)<=1)
            % FOR THE MASK -----------------------------------------------
            %xv = (Q1(1,1)):-1:(Q1(1,1)-smpWidth);
            % FOR THE MASK -----------------------------------------------
            xv = (Q1(1,1)):-1:1;
            yv = m*(xv) + c;
            
            Tind = logical((yv>maxsize)+(yv<1));
            yv(Tind) = [];
            xv(Tind) = [];
%             Tind = (yv<1);
%             xv(Tind) = [];
%             yv(Tind) = [];
            xyflag = 1;
        else
            % FOR THE MASK -----------------------------------------------
            %yv = (Q1(1,2)):-1:(Q1(1,2)-smpWidth);
            % FOR THE MASK -----------------------------------------------
            yv = (Q1(1,2)):-1:1;
            xv  = (yv-c)/m;
            
            Tind = logical((xv>maxsize)+(xv<1));
            xv(Tind) = [];
            yv(Tind) = [];
%            Tind = (xv<1);
%             xv(Tind) = [];
%             yv(Tind) = [];            
            xyflag = 2;
        end 
    flag = 2;    %Have + M & Going further UP with MASK (MASK MUST TURN 180)
    
    else         %SPECIAL CASE m = +/- INF
        disp('SPECIAL CASE m = INF')
        if((Q1(2,2)-Q1(1,2))<0) % EMPIRICAL SETTING
            yv = (Q1(1,2)):-1:1;
            xv = Q1(1,1)*ones(1, size(yv,2));
        else
            yv = (Q1(1,2)):1:yRsize;
            xv = Q1(1,1)*ones(1, size(yv,2));
        end                   
    end
        
else %Means with Negative m values
    if(Qdif > 0);
         if (abs(m)<=1)
             % FOR THE MASK -----------------------------------------------
            %xv = (Q1(1,1)):-1:(Q1(1,1)-smpWidth); 
            % FOR THE MASK -----------------------------------------------
            xv = (Q1(1,1)):-1:1;
            yv = m*(xv) + c;
            
            Tind = logical((yv>maxsize)+(yv<1));
            yv(Tind) = [];
            xv(Tind) = [];
%             Tind = (yv>yRsize);
%             xv(Tind) = [];
%             yv(Tind) = [];
            xyflag = 1;
         else
            % FOR THE MASK -----------------------------------------------
            %yv = (Q1(1,2)):1:(Q1(1,2)+smpWidth);
            % FOR THE MASK -----------------------------------------------
            yv = (Q1(1,2)):1:yRsize;
            xv  = (yv-c)/m;
            
            Tind = logical((xv>maxsize)+(xv<1));
            xv(Tind) = [];
            yv(Tind) = [];
%             Tind = (xv<1);
%             xv(Tind) = [];
%             yv(Tind) = [];
            xyflag = 2;
        end 
    flag = 3;    %Have - M & Coming further Down with MASK (MASK right)
    else
        if (abs(m)<=1)
            % FOR THE MASK -----------------------------------------------
            %xv = (Q1(1,1)):1:(Q1(1,1)+smpWidth); 
            % FOR THE MASK -----------------------------------------------
            xv = (Q1(1,1)):1:xCsize;
            yv = m*(xv) + c;
            
            Tind = logical((yv>maxsize)+(yv<1));
            yv(Tind) = [];
            xv(Tind) = [];
%             Tind = (yv<1);
%             xv(Tind) = [];
%             yv(Tind) = [];
            xyflag = 1;
        else
            % FOR THE MASK -----------------------------------------------
            %yv = (Q1(1,2)):-1:(Q1(1,2)-smpWidth);
            % FOR THE MASK -----------------------------------------------
            yv = (Q1(1,2)):-1:1;
            xv  = (yv-c)/m;
            
            Tind = logical((xv>maxsize)+(xv<1));
            xv(Tind) = [];
            yv(Tind) = [];
%             Tind = (xv>xCsize);
%             xv(Tind) = [];
%             yv(Tind) = [];
            xyflag = 2;
        end 
    flag = 4;    %Have - M & Going further UP with MASK (MASK MUST TURN 180)
    end    
end



%pause


%pause


% FOR THE MASK ----------------------------------------------------------
%Correcting the MASK if the Initial Direction is Wrong...
% if ((flag==2)||(flag==4))
% 
%     J = imrotate(J,180,'crop');
%     
% end
% FOR THE MASK ----------------------------------------------------------

% ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% COMMENTED - TO AVOID END POINT CORRECTION
% ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
%     %INITIAL ROUND...OUTSIDE THE LOOP...
%     tempC = [xv(1) yv(1)];
%     tempC1 = tempC - [11 11];
%     tempC2 = floor(tempC);
% 
%     Val = [];
% 
%     Sect = I2(tempC1(2):(tempC1(2)+sz),tempC1(1):(tempC1(1)+sz));
%     Val = [Val;I2(tempC2(2),tempC2(1))];
% 
%     SectR = Sect.*J;
%     RES = [];
%     MaxC = sum(SectR(:));
%     RES = [RES;MaxC];
%     round=1;
% 
%     for i=2:smpWidth
% 
%     tempC = [xv(i) yv(i)];
%     tempC1 = tempC - [11 11];
%     tempC2 = floor(tempC);
% 
%     Sect = I2(tempC1(2):(tempC1(2)+sz),tempC1(1):(tempC1(1)+sz));
% 
%     SectR = Sect.*J;
%     RES = [RES; sum(SectR(:))];
%     Val = [Val;I2(tempC2(2),tempC2(1))];
%     round = round + 1;
%     end
% 
%     %RES;
%     %-------------Just to De-Bug---------
%     %disp('DEBUG ONLY!')
%     list = (1:smpWidth)';
%     RES1 = [list RES Val];
% 
%     %------------------------------------
% 
%     %Finding the Maximum and the Index
%     maxV = max(RES);
%     maxInd = find(RES==maxV);
% 
%     RES2 = RES(maxInd:smpWidth);
%     list2 = (maxInd:smpWidth)';
%     Val2 = Val(maxInd:smpWidth);
% 
%     valmax = Val2(1);
%     valmin = min(Val2);
%     gapthr = 0.1*(valmax-valmin);
% 
%     for t=maxInd:(smpWidth-1)
%         t;
%         gap = Val(t)-Val(t+1);
%         if(gap<gapthr)
%             break
%         end    
%     end
% 
%     brkind = t;
%     offsetv = brkind - maxInd;
%     [xypnts1,numpntS1]=MyEndPoints(xv,yv,Q1,xyflag,brkind,1);
% 
%     spnts3 = 0;
%     if (~isempty(numpntS1))
%         spnts3 = spnts3+ numpntS1;
% 
%     else
%         disp('----------------')
%         disp('SECOND SCENARIO CALLED ON!')
%         valmax = Val(1);
%         valmin = min(Val);
%         gapthr = 0.1*(valmax-valmin);
% 
%         for t=smpWidth:-1:2
%             t;
%             gap = Val(t-1)-Val(t);
%             if(gap>gapthr)
%                 break
%             end    
%         end
%         t;
%         [xypnts1,numpntS1]=MyEndPoints(xv,yv,Q1,xyflag,t,1);
% 
%         if (~isempty(numpntS1))
%             spnts3 = spnts3+ numpntS1;
%         %else
%             %disp('MALA MALA MALA MALA MALA MALA MALA MALA!!!!!!!')
%         end              
%     end
% ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% COMMENTED - TO AVOID END POINT CORRECTION
% ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    
%==========================================================================
%
%=======================================================================
disp('--------------------------------------------------------')
% FOR END #2 ONLY
disp('FOR END #2 ONLY')
    if (EndReverse==0)  %Normal way - End2 <-> Telo2
        disp('Normal way - End2 <-> Telo2')
        if (flagTel2==1)%There is a WIGGLE At Tel2 for End2
            disp('There is a WIGGLE At Tel2 for End2')
            Q1p = [SamP(end-1,:);Tel2PntT]
        else            %There is NO WIGGLE - USUAL
            disp('There is NO WIGGLE - USUAL')
            Q1p = SamP(end-1:end,:)          
        end
        
    else                %Changed - End2 <-> Telo1
        disp('Changed - End2 <-> Telo1')
        if (flagTel1==1)%There is a WIGGLE At Tel1 for End2
            disp('There is a WIGGLE At Tel1 for End2')
            Q1p = [SamP(end-1,:);Tel1PntT]
        else            %There is NO WIGGLE - USUAL
            disp('There is NO WIGGLE - USUAL')
            Q1p = SamP(end-1:end,:)       
        end
        
    end
    
%pause

%______________________________________________________________________
% if(flagEnd2==1)
%     if (EndReverse==0)
%         Q1p = [SamP(end,:);End2PntT];
%     else
%         Q1p = [SamP(end,:);End1PntT];
%     end
% else
%     Q1p = SamP(end-1:end,:);
% end
%______________________________________________________________________

%Q1p = SamP(end-1:end,:);

Qdifp = Q1p(1,1)-Q1p(2,1);

mp = (Q1p(2,2)-Q1p(1,2))/(Q1p(2,1)-Q1p(1,1));


% if((mp==Inf)||(mp==-Inf))
%     mp = 57
% end

if((mp==Inf))
    mp = 57;
end

if((mp==-Inf))
    mp = -57;
end

cp = (Q1p(1,2))-(mp*Q1p(1,1));

% FOR THE MASK ----------------------------------------------------------
% if (mp>0)
%     angRp = atan(mp);
%     angp = -90 -1*(180*angRp)/pi;
% else
%     %T = 180 -(1*(180*angR)/pi) 
%     %ang = -90 -T  
%     m1p = -1/mp;
%     angRp = atan(m1p);
%     angp = -180 -1*(180*angRp)/pi;   
% end
% 
% Jp = imrotate(Mask,angp,'crop');

% FOR THE MASK ----------------------------------------------------------

if (mp>=0)    
    if(Qdifp < 0)
        if (abs(mp)<=1)
            % FOR THE MASK------------------------------------------------
            %xvp = (Q1p(1,1)):1:(Q1p(1,1)+smpWidth); 
            % FOR THE MASK------------------------------------------------
            xvp = (Q1p(1,1)):1:xCsize;
            yvp = mp*(xvp) + cp;
            
            Tind = logical((yvp>maxsize)+(yvp<1));
            yvp(Tind) = [];
            xvp(Tind) = [];
%             Tind = (yvp>yRsize);
%             xvp(Tind) = [];
%             yvp(Tind) = [];            
            xyflagp = 1;
        else
            % FOR THE MASK------------------------------------------------
            %yvp = (Q1p(1,2)):1:(Q1p(1,2)+smpWidth);
            % FOR THE MASK------------------------------------------------
            yvp = (Q1p(1,2)):1:yRsize;
            xvp  = (yvp-cp)/mp;
            
            Tind = logical((xvp>maxsize)+(xvp<1));
            xvp(Tind) = [];
            yvp(Tind) = [];
%             Tind = (xvp>xCsize);
%             xvp(Tind) = [];
%             yvp(Tind) = [];
            xyflagp = 2;
        end 
    flagp = 1;    %Have + M & Coming further Down with MASK (MASK right)
    elseif(Qdifp > 0)
        if (abs(mp)<=1)
            % FOR THE MASK------------------------------------------------
            %xvp = (Q1p(1,1)):-1:(Q1p(1,1)-smpWidth); 
            % FOR THE MASK------------------------------------------------
            xvp = (Q1p(1,1)):-1:1; 
            yvp = mp*(xvp) + cp;
            
            Tind = logical((yvp>maxsize)+(yvp<1));
            yvp(Tind) = [];
            xvp(Tind) = [];
%             Tind = (yvp<1);
%             xvp(Tind) = [];
%             yvp(Tind) = [];
            xyflagp = 1;
        else
            % FOR THE MASK------------------------------------------------
            %yvp = (Q1p(1,2)):-1:(Q1p(1,2)-smpWidth);
            % FOR THE MASK------------------------------------------------
            yvp = (Q1p(1,2)):-1:1;
            xvp  = (yvp-cp)/mp;
            
            Tind = logical((xvp>maxsize)+(xvp<1));
            xvp(Tind) = [];
            yvp(Tind) = [];
%             Tind = (xvp<1);
%             xvp(Tind) = [];
%             yvp(Tind) = [];            
            xyflagp = 2;
        end
    flagp = 2;    %Have + M & Going further UP with MASK (MASK MUST TURN 180)
    
    else         %SPECIAL CASE m = +/- INF
        disp('SPECIAL CASE m = INF')
        if((Q1p(2,2)-Q1p(1,2))<0) % EMPIRICAL SETTING
            yvp = (Q1p(1,2)):-1:1;
            xvp = Q1p(1,1)*ones(1, size(yvp,2));
        else
            yvp = (Q1p(1,2)):1:yRsize;
            xvp = Q1p(1,1)*ones(1, size(yvp,2));
        end                   
    end
    
    
        
else %Means with Negative m values
    if(Qdifp > 0)
        if (abs(mp)<=1)
            % FOR THE MASK------------------------------------------------
            %xvp = (Q1p(1,1)):-1:(Q1p(1,1)-smpWidth); 
            % FOR THE MASK------------------------------------------------
            xvp = (Q1p(1,1)):-1:1;
            yvp = mp*(xvp) + cp;
            
            Tind = logical((yvp>maxsize)+(yvp<1));
            yvp(Tind) = [];
            xvp(Tind) = [];
%             Tind = (yvp>yRsize);
%             xvp(Tind) = [];
%             yvp(Tind) = [];            
            xyflagp = 1;
        else
            % FOR THE MASK------------------------------------------------
            %yvp = (Q1p(1,2)):1:(Q1p(1,2)+smpWidth);
            % FOR THE MASK------------------------------------------------
            yvp = (Q1p(1,2)):1:yRsize;
            xvp  = (yvp-cp)/mp;
            
            Tind = logical((xvp>maxsize)+(xvp<1));
            xvp(Tind) = [];
            yvp(Tind) = [];
%             Tind = (xvp<1);
%             xvp(Tind) = [];
%             yvp(Tind) = [];            
            xyflagp = 2;
        end
    flagp = 3;   %Have - M & Coming further Down with MASK (MASK right)
    else
        if (abs(mp)<=1)
            % FOR THE MASK------------------------------------------------
            %xvp = (Q1p(1,1)):1:(Q1p(1,1)+smpWidth); 
            % FOR THE MASK------------------------------------------------
            xvp = (Q1p(1,1)):1:xCsize ;
            yvp = mp*(xvp) + cp;
            
            Tind = logical((yvp>maxsize)+(yvp<1));
            yvp(Tind) = [];
            xvp(Tind) = [];
%             Tind = (yvp<1);
%             xvp(Tind) = [];
%             yvp(Tind) = [];            
            xyflagp = 1;
        else
            % FOR THE MASK------------------------------------------------
            %yvp = (Q1p(1,2)):-1:(Q1p(1,2)-smpWidth);
            % FOR THE MASK------------------------------------------------
            yvp = (Q1p(1,2)):-1:1;
            xvp  = (yvp-cp)/mp;
            
            Tind = logical((xvp>maxsize)+(xvp<1));
            xvp(Tind) = [];
            yvp(Tind) = [];
%             Tind = (xvp>xCsize);
%             xvp(Tind) = [];
%             yvp(Tind) = [];
            xyflagp = 2;
        end
    flagp = 4;    %Have - M & Going further UP with MASK (MASK MUST TURN 180)
    end  
end

% FOR THE MASK ----------------------------------------------------------
% if ((flagp==2)||(flagp==4))
%     Jp = imrotate(Jp,180,'crop');   
% end
% FOR THE MASK ----------------------------------------------------------

%pause

Ordfill = OrdfillInt;

if (figflag==1)
    figure
    imshow(I,[])
    hold on
    plot(Ordfill(:,1),Ordfill(:,2),'*b')
    hold on
    plot(SamP(:,1),SamP(:,2),'sw')
    hold on
    plot(Tel1PntT(1,1),Tel1PntT(1,2),'om')
    hold on
    plot(Tel2PntT(1,1),Tel2PntT(1,2),'om')
    hold on
    plot(xv,yv,'*y')
    hold on
    plot(xvp,yvp,'*r')
    hold off
end

%pause

% ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% COMMENTED - TO AVOID END POINT CORRECTION
% ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
%     %INITIAL ROUND...OUTSIDE THE LOOP...
%     tempCp = [xvp(1) yvp(1)];
%     tempC1p = tempCp - [11 11];
%     tempC2p = floor(tempCp);
% 
%     Valp = [];
% 
%     Sectp = I2(tempC1p(2):(tempC1p(2)+sz),tempC1p(1):(tempC1p(1)+sz));
%     Valp = [Valp;I2(tempC2p(2),tempC2p(1))];
% 
% 
%     SectRp = Sectp.*Jp;
%     RESp = [];
%     MaxCp = sum(SectRp(:));
%     RESp = [RESp;MaxCp];
% 
%     roundp=1;
% 
%     for i=2:smpWidth
% 
%     tempCp = [xvp(i) yvp(i)];
%     tempC1p = tempCp - [11 11];
%     tempC2p = floor(tempCp);
% 
%     Sectp = I2(tempC1p(2):(tempC1p(2)+sz),tempC1p(1):(tempC1p(1)+sz));
% 
% 
%     SectRp = Sectp.*Jp;
%     RESp = [RESp; sum(SectRp(:))];
%     Valp = [Valp;I2(tempC2p(2),tempC2p(1))];
% 
%     roundp = roundp + 1;
%     end
% 
% 
%     %RESp;
%     %-------------Just to De-Bug---------
%     listp = (1:smpWidth)';
%     RES1p = [listp RESp Valp];
%     %-------------------------------------
% 
%     %Here the Max Finding part is Missing..
%     %Finding the Maximum and the Index
%     maxVp = max(RESp);
%     maxIndp = find(RESp==maxVp);
% 
%     RES2p = RESp(maxIndp:smpWidth);
%     list2p = (maxIndp:smpWidth)';
%     Val2p = Valp(maxIndp:smpWidth);
%     valmaxp = Val2p(1);
%     valminp = min(Val2p);
%     gapthrp = 0.1*(valmaxp-valminp);
% 
%     for tp=maxIndp:(smpWidth-1)
%         tp;
%         gap = Valp(tp)-Valp(tp+1);
%         if(gap<gapthrp)
%             break
%         end    
%     end
% 
%     brkindp = tp;
%     offsetvp = brkindp - maxIndp;
% 
%     [xypnts2,numpntS2]=MyEndPoints(xvp,yvp,Q1p,xyflagp,brkindp,2);
% 
% 
%     if (~isempty(numpntS2))
%         spnts3 = spnts3+ numpntS2;
%     else
%         disp('----------------')
%         disp('SECOND SCENARIO CALLED ON!')
%         valmaxp = Valp(1);
%         valminp = min(Valp);
%         gapthrp = 0.1*(valmaxp-valminp)
% 
%         for tp=smpWidth:-1:2
%             tp;
%             gap = Valp(t-1)-Valp(t);
%             if(gap>gapthrp)
%                 break
%             end    
%         end
%         tp;
%         [xypnts2,numpntS2]=MyEndPoints(xvp,yvp,Q1p,xyflagp,tp,2);
% 
%         if (~isempty(numpntS2))
%             spnts3 = spnts3+ numpntS2;
%         %else
%             %disp('MALA MALA MALA MALA MALA MALA MALA MALA!!!!!!!')
%         end              
%     end
% 
%     if (~isempty(numpntS1))
%         szseg1 = numpntS1;          %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     else
%         szseg1 = 0;                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     end
% 
%     if (~isempty(numpntS2))    
%         szseg2 = numpntS2;          %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     else
%         szseg2 = 0;                 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     end
% 
% 
%     OrdfillPad = Ordfill + padFac;
%     OrdfillPad = [xypnts1;OrdfillPad;xypnts2];
% 
%     xyps1 = xypnts1 - padFac;
%     xyps2 = xypnts2 - padFac;
%     Ordfill = [xyps1;Ordfill;xyps2];
% 
% 
% 
% 
% 
% 
%     % numpntS1
%     % numpntS2
%     save (fname,'Ordfill')
% ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
% COMMENTED - TO AVOID END POINT CORRECTION
% ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++



% figure
% imshow(Ia,[])
% hold on
% plot(xypnts1(:,1),xypnts1(:,2),'ro','LineWidth',2);
% text(xypnts1(:,1), xypnts1(:,2),[repmat('  ',numpntS1,1), num2str((1:numpntS1)')])
% hold on
% plot(xypnts2(:,1),xypnts2(:,2),'bo','LineWidth',2);
% text(xypnts2(:,1), xypnts2(:,2),[repmat('  ',numpntS2,1), num2str((1:numpntS2)')])
% hold off


%%This is the CENTERLINE PLOT - END POINTS CORRECTED!
% figure
% imshow(Ia,[])
% hold on
% %plot(OrdfillPad(:,1),OrdfillPad(:,2),'mo','LineWidth',2);
% %hold on
% plot(OrdfillPad(:,1),OrdfillPad(:,2),'k','LineWidth',2);

%-----------------------

