function [ptel1,ptel2,pside1,pside2] = autosegment(aaA,bbA,xxA,yyA,I,tx1A,ty1A)

%Program created for automatically segmenting the contour partitions based
%on the DCE points (6 points) - This attempts to select the 4 telomere
%points of the chromosome.

clc


doneflag = 0;


aaA = aaA';
bbA = bbA';
cont = [aaA bbA]

len = size(cont,1)

xxA(end) = [];
yyA(end) = [];
Points = [xxA yyA]
n = size(Points,1);

indlist = [];

for i=1:6

    T = [xxA(i) yyA(i)];
    T = repmat(T,len,1);
    ind = (cont==T);
    ind = sum(ind,2);
    indv = find(ind==2);
    indlist = [indlist; indv];
    
end

indlist

T = circshift(indlist,-1);
fdist = T-indlist;
tval = (len - indlist(end)) + T(end);

fdist(end) = tval

bdist = circshift(fdist,1)

distset = [fdist bdist]

distThr = len/7

disind = find(sum(distset>distThr,2)==2)

if (~isempty(disind))
    A = 9;
    
    szlrg = size(disind,1)
    
    if(szlrg < 3)
        disp('One or Two Points')
        Points(disind,:) = [];
        distset(disind,:) = [];
        indlist(disind,:) = [];
        n = n - szlrg;
            if (szlrg == 2)
                doneflag = 1
            end
        
    else
        disp('More Than Two Points')
        Points(disind(1:2),:) = [];
        distset(disind(1:2),:) = [];
        indlist(disind(1:2),:) = [];
        n = n - 2;
        doneflag = 1
    end
    
else
    disp('Nothing Reduced...all 6 remains')
end

Points
distset
n
indlist
len

figure
imshow(I,[])
hold on
plot(Points(:,2),Points(:,1),'sb','linewidth',5)
hold on
plot(bbA,aaA,'r')
% hold on
% plot(Z(:,2),Z(:,1),'y')
hold off
title('Current Result-1')

pause

if (~doneflag)
    
    
    
%     Xset = []; %DELETE THIS LATER
%     Yset = []; %DELETE THIS LATER
%     
%     DX = [];
%     DY = [];
%     gap = 4;
%     
%     n
%     len
%     for k=1:n
%         %k
%         %INDVOKK = indlist(k)
%         bkind = indlist(k) - gap
% 
%         if(bkind < 1)
%             disp('Special-BACK')
%             rest = indlist(k) - 1
%             bkind = len - (gap - rest)
%         end
% 
%         fwind = indlist(k) + gap
% 
%         if(fwind > len)
%             disp('Special-FORWARD')
%             rest = len - indlist(k)
%             fwind = 1 + (gap - rest)
%         end
% 
%         Xset = [Xset; aaA(bkind) aaA(indlist(k)) aaA(fwind)]; %DELETE THIS LATER
%         Yset = [Yset; bbA(bkind) bbA(indlist(k)) bbA(fwind)]; %DELETE THIS LATER
%         
%         DX = [DX; (aaA(bkind)-aaA(indlist(k)))-(aaA(indlist(k))-aaA(fwind))]; 
%         DY = [DY; (bbA(bkind)-bbA(indlist(k)))-(bbA(indlist(k))-bbA(fwind))];
%         
%         
%     end
% 
%     Xset
%     DX
%     Yset
%     DY
%     
%     MAG = sqrt(DX.^2 + DY.^2)
% 
%     %   Correcting for 90 deg MATH Error.
%     
%     corind = (DY==0)
%     DY(corind) = 0.001
%     DX
%     
%     alpv = atan(DX./DY)*(180/pi)
%     
%     %   Now lets remove remaining points based on the curvature.
%     
%     n
%     [mins,IX] = sort(MAG,1)
%     
%     if (n==6)
%         indT = IX(1:2)
%     else
%         indT = IX(1)
%     end
%     
%     
%     Points(indT,:) = [];
%     distset(indT,:) = [];
%     indlist(indT,:) = [];
%     
%         
%     
%     
%     
%     
% %   Correcting for 90 deg MATH Error.
% %     corind = (DY==0)
% %     DX
% %     DY(corind) = 0.001
% %     
% %     alpv = atan(DX./DY)*(180/pi)
% %     
% %     thetav = alpv(:,1) + alpv(:,2) % This is the Angle value.....
%     
% %     %Now lets first remove concave DCE point/points...
% %     %Looking at the signs of the angles
% %     posplace = (thetav>=0) %Positive Indices
% %     pospnts = sum(posplace) %No of + ves
% %     negplace = (thetav<0)  %Negative Indices
% %     negpnts = sum(negplace) %No of - ves
% %     
% %     if (pospnts>=4)
% %         disp('Convex points have + ve Theta values')
% %         Points(negplace,:) = []
% %         distset(negplace,:) = []
% %         indlist(negplace,:) = []
% %         n = n - negpnts
% %         
% %     else
% %         disp('Convex points have - ve Theta values')
% %         Points(posplace,:) = []
% %         distset(posplace,:) = []
% %         indlist(posplace,:) = []
% %         n = n - pospnts
% %     end
%       
    
end


ptel1 =1;
ptel2 =2;
pside1=3;
pside2=4;




figure
imshow(I,[])
hold on
plot(Points(:,2),Points(:,1),'sb','linewidth',5)
hold on
plot(bbA,aaA,'r')
% hold on
% plot(Z(:,2),Z(:,1),'y')
hold off
title('Current Result-2')

%T2 = [x1A y1A]






