function [EucLVal] = findEuclength(lineS)
%findEuclength This function returns the eucleudian length of a line segment.
%   Detailed explanation goes here

lineST = circshift(lineS,-1);

diffV = lineST - lineS;
diffV(end,:) = [];

diffVSq = diffV.*diffV;

diffVal = sqrt(sum(diffVSq,2));

EucLVal = sum(diffVal);

end

