function [LIR] = getinitContour(AT)
% Author - Akila Mike 
% Last Edited - 21-Nov-2009
% The function traces the BINARY contour of an thresholded image and
% returns the Linear Indices in 'LIR'


%A = rgb2gray(AT);
A = AT;
A2 = bwmorph(A,'clean');
A3T = bwmorph(A2,'spur');
A3T2 = bwmorph(A3T,'majority');

Acont = bwmorph(A3T2,'remove');
%imshow(Acont)

AF = Acont;
sizeR = size(AF,1);
LI = find(AF);
LIR = calcIndex(LI,sizeR);

xT = LIR(:,2);
yT = LIR(:,1);

			 [B,L,N,A] = bwboundaries(AF,8,'noholes');
			 boundary = B{1};

 LIR = boundary;