 % Last Revised - 21-Nov-2009 - Akila Mike
  function [x,y] = gvfsnakeEvolve(I,AT)

   % Read in the 64x64 room image
     %[I,map] = rawread('NewS3.pgm'); 
     
     
   % Compute its edge map
    %%disp(' Compute edge map ...');                  %Commented Later
     %f = 1 - I/255; 
     f = edge(I,'canny');
     f = double(f);

   % Compute the GVF of the edge map f
     %disp(' Compute GVF ...');                       %Commented Later
     [px,py] = GVF(f, 0.2, 80); 
     %[px,py] = GVF(f, 0.23, 80);

   % display the results
%      figure(1);                                     %Commented Later 
%      subplot(221); imdisp(I); title('test image');  %Commented Later
%      subplot(222); imdisp(f); title('edge map');    %Commented Later

     % display the gradient of the edge map
     [fx,fy] = gradient(f); 
     %subplot(223); quiver(fx,fy);                    %Commented Later
     %axis off; axis equal; axis 'ij';     % fix the axis %Commented Later 
     %title('edge map gradient');                     %Commented Later

     % display the GVF 
     %subplot(224); quiver(px,py);                    %Commented Later
     %axis off; axis equal; axis 'ij';     % fix the axis %Commented Later
     %title('GVF field');                             %Commented Later
       
   % snake deformation
     %disp(' Press any key to start GVF snake deformation');
     %pause;
     %figure(1); subplot(221);                        %Commented Later
     %colormap(gray(64));                             %Commented Later
     %imshow(I,[]);                                   %Commented Later
     %image(((1-f)+1)*40);
     %axis('square', 'off');                          %Commented Later
%      t = 0:0.5:6.28;
     
%      x = 29 + 3*cos(t);
%      y = 29 + 3*sin(t);
%THE PART TO GET THE PROPER X , Y AXIS
     [Z] = getinitContour(AT);
     x = Z(:,2);
     y = Z(:,1);
%THAT PART ENDS HERE....
     
     [x,y] = snakeinterp(x,y,2,0.5);
     %snakedisp(x,y,'r');                             %Commented Later
     %pause(1);                                       %Commented Later

     for i=1:25,
       [x,y] = snakedeform(x,y,0.05,0,1,2,px,py,5);
       [x,y] = snakeinterp(x,y,2,0.5);
       %snakedisp(x,y,'r')                            %Commented Later 
       %title(['Deformation in progress,  iter = ' num2str(i*5)])
       %pause(0.1);
     end

     %disp(' Press any key to display the final result');
     %pause;
     %figure(1); subplot(221);                        %Commented Later
     %colormap(gray(64));                             %Commented Later 
     %imshow(I,[]);                                   %Commented Later
     %image(((1-f)+1)*40); 
     %axis('square', 'off');                          %Commented Later
     %snakedisp(x,y,'r');                             %Commented Later 
     %title(['Final result,  iter = ' num2str(i*5)]); %Commented Later
     

