function [X1, Y1, RecMidPnt] = laplaciansub(A, I, LblObjBack, LblLftRgt, line1, line2, NumbPnts)
% Author -  AKILA MIKE
% Date - June 2011
% This function calculates the Laplacian solution for the setup (passed as
% arguments). Also calles the routine to trace the thickness of these line
% segments.

% load setupresults.mat

Threshld = 100;
OldSval  = 0;
iteration = 0;


Oneind = (LblLftRgt==1);
Twoind = (LblLftRgt==2);

Aback = A;

%figure
%B = A;

threshval = 0.0000000001;
%while (Threshld>=eps),  
while (Threshld>=threshval)
    iteration = iteration + 1;
    
    % enforce boundary conditions
%     A(1,:) = 0;
%     A(gridsize(1),:) = 0;


      A(Oneind) = 1;
      A(Twoind) = 0;
    

    
    % draw what we have
%     if (mod(iteration,100)==0),
%       imagesc(A);
%       colorbar;
%       drawnow;
%     end
    
    % incrementally solve laplace's equation by setting every cell equal
    % to the average value of the neighboring cells    
    
    
    B = 0;
    %C = [];
%     for x=[-1 0 1]
%         for y=[-1 0 1],
%             if (x~=0 || y ~=0),
%                 B = B + circshift(A, [x y]);
%             end
%         end
%     end

    
    %DY = circshift(A,[1 0]) + circshift(A,[-1 0])

    %DX = circshift(A,[0 -1]) + circshift(A,[0 1])
    B = B + circshift(A,[1 0]);
    B = B + circshift(A,[-1 0]);
    B = B + circshift(A,[0 -1]);
    B = B + circshift(A,[0 1]);
    
    B = B + circshift(A,[1 1]);
    B = B + circshift(A,[-1 1]);
    B = B + circshift(A,[1 -1]);
    B = B + circshift(A,[-1 -1]);
       

%     B = del2(B);
    C = abs(A - B/8);
    %C = abs(A - B/4);
    
    
    %whos 
    %iteration
    Sval = sum(C(:));
    
    Threshld = abs(Sval-OldSval);
    OldSval = Sval;
    
    %pause(0.1)
    %A = B/4;
    A = B/8;
    
end



% figure
% [XC,h] = contour(A,10);
% clabel(XC,h)
% colorbar;
% drawnow;

DY = (circshift(A,[-1 0]) - circshift(A,[1 0]))/2;

DX = (circshift(A,[0 -1]) - circshift(A,[0 1]))/2;

MAGDXY = sqrt((DX.*DX)+(DY.*DY));

NY = DY./MAGDXY;
NX = DX./MAGDXY;

% figure
% imshow(NX,[])
% % imagesc(NX)
% % colorbar;
% % drawnow;
% 
% figure
% imshow(NY,[])
% % imagesc(NY)
% % colorbar;
% % drawnow;

figure
%imagesc(I)
imshow(I,[])
%imshow(Aback,[])
hold on

[X1, Y1, RecMidPnt] = tracethickness(A, line1, line2, NX, NY, MAGDXY, LblLftRgt, LblObjBack, 'Normal Results', NumbPnts);