function [mu] = momentous(xv, dv, momentNumber,n)
% fv -> xv, 
% lv -> dv,

mu = 0;
prevX = xv(1);
prevD = dv(1);

for i=2:n
    currX = xv(i);
    currD = dv(i);
    
    mu = mu + ((currD.^(momentNumber+1) - prevD.^(momentNumber+1))*(0.5*currX + 0.5*prevX))/(momentNumber+1);
    prevX = currX;
    prevD = currD;
    
end
    
    



