function [fac pnts smpWidth StopFlag] = mySpacingCalc(PA1,intskllng)
%Author - AKILA MIKE SUBASINGHE
%Calculates Proper Factors for Sampling Based on the Path Length...

StopFlag = 0;       % This flag will be set if the chromosome is too short.

sizeA = size(PA1,1)


if(intskllng>120)   
    pnts = ceil(sizeA/9)
    data1 = round(sizeA/7)
    fac = round(data1/2);
    smpWidth  = ceil(sizeA/5.5);
    
elseif(intskllng>100)  
    pnts = ceil(sizeA/7)
    data1 = round(sizeA/6)
    fac = round(data1/2);
    smpWidth  = ceil(sizeA/5.0);

elseif(intskllng>90)  
    pnts = ceil(sizeA/7)
    data1 = round(sizeA/5.5)
    fac = round(data1/2);
    smpWidth  = ceil(sizeA/4.5);
    
elseif(intskllng>80)  
    pnts = ceil(sizeA/7)
    data1 = round(sizeA/5.2)
    fac = round(data1/2);
    smpWidth  = ceil(sizeA/4.0);
    
elseif(intskllng>70)  
    pnts = ceil(sizeA/7)
    data1 = round(sizeA/5)
    fac = round(data1/2);
    smpWidth  = ceil(sizeA/3.5);
    
    
elseif(intskllng>60)  
    pnts = ceil(sizeA/7)
    data1 = round(sizeA/4.5)
    fac = round(data1/2);
    smpWidth  = ceil(sizeA/2.5);


elseif(intskllng>50)
    pnts = ceil(sizeA/6)
    data1 = round(sizeA/4)
    fac = round(data1);
    smpWidth  = ceil(sizeA/1);    
    
else
    pnts = ceil(sizeA/6)
    data1 = round(sizeA/4)
    fac = round(data1);
    smpWidth  = ceil(sizeA/1);  
%     StopFlag = 1; 
%     fac = 1;
%     pnts = 1;
%     smpWidth = 1;
end
