function [setofIndmin,Rmyfindminimas,Specialcaseornot] = myfindminimas2NewF(Cent1,CentroWidthSS)
% 2013 Creates the centromere candidate feature set. 

    dividefact = 5
    %t = 7;
    p = 0;

    leng = size(Cent1,1)
    lengVec = (1:leng);
    
    Cent   = Cent1;
    maxCent =  max(Cent);
    Cent = Cent/maxCent;
    %Centnorm = Cent;
    %display('Check this value:')
    %max(Cent)
    %min(Cent)
    %pause
    
    figure
    plot(Cent,'*-g','linewidth',2)
    hold on
    grid on
    grid minor
    title('WIDTH PROFILE')
    
    
    setofIndmin = [];
    Specialcaseornot = [];
    
    setofIndmax = [];
    
    setofLeftind = [];
    setofRightind = [];
    
    setofLeftgap = [];
    setofRightgap = [];
    
    setofIndminV = [];
    setofgaps = [];
    szCent = size(Cent,1);
    data = Cent';
    
%         for i=3:szCent-2
%                 if((Cent(i-1)>Cent(i)) && (Cent(i+1)>Cent(i)) && (Cent(i-2)>Cent(i)) && (Cent(i+2)>Cent(i)))
%                     setofIndmin = [setofIndmin;i];
%                     plot(i,Cent(i),'*b','linewidth',3)
%                 end
% 
%                 if((Cent(i-1)<Cent(i)) && (Cent(i+1)<Cent(i)) && (Cent(i-2)<Cent(i)) && (Cent(i+2)<Cent(i)))
%                     setofIndmax = [setofIndmax;i];
%                     plot(i,Cent(i),'*r','linewidth',3)
%                 end
%         end 

            for i=2:szCent-1
                
                if(i==2)
                    if((Cent(i-1)>Cent(i)) && (Cent(i+1)>Cent(i)))
                        setofIndmin = [setofIndmin;i];
                        Specialcaseornot = [Specialcaseornot;1];   %One means its a special case.
                        plot(i,Cent(i),'sb','linewidth',3)
                    end

%                     if((Cent(i-1)<Cent(i)) && (Cent(i+1)<Cent(i)))
%                         setofIndmax = [setofIndmax;i];
%                         plot(i,Cent(i),'sr','linewidth',3)
%                     end
                elseif(i==szCent-1)
                    if((Cent(i-1)>Cent(i)) && (Cent(i+1)>Cent(i)))
                        setofIndmin = [setofIndmin;i];
                        Specialcaseornot = [Specialcaseornot;1];   %One means its a special case.
                        plot(i,Cent(i),'sb','linewidth',3)
                    end

%                     if((Cent(i-1)<Cent(i)) && (Cent(i+1)<Cent(i)))
%                         setofIndmax = [setofIndmax;i];
%                         plot(i,Cent(i),'sr','linewidth',3)
%                     end
                    
                else                                    
                    if((Cent(i-1)>Cent(i)) && (Cent(i+1)>Cent(i)) && (Cent(i-2)>Cent(i)) && (Cent(i+2)>Cent(i)))
                        setofIndmin = [setofIndmin;i];
                        Specialcaseornot = [Specialcaseornot;0];
                        plot(i,Cent(i),'*b','linewidth',3)
                    end

%                     if((Cent(i-1)<Cent(i)) && (Cent(i+1)<Cent(i)) && (Cent(i-2)<Cent(i)) && (Cent(i+2)<Cent(i)))
%                         setofIndmax = [setofIndmax;i];
%                         plot(i,Cent(i),'*r','linewidth',3)
%                     end
                end
            end 
        


    %%%% CODE ADDED TO ACCOMODATE CASES WHERE THERE ARE NO MINIMAS
    %%%% DETECTED.
    
    if(size(setofIndmin,1)==0) %Means no Minima found
        %Now pick the global minima and be done with it :D
        disp('NO NORMAL MINIMA DETECTED!!!')
        Specialcaseornot = [Specialcaseornot;1];
        minValEx = min(Cent(:))
        minVTInd = find(Cent==minValEx)
        
        if(size(minVTInd,1)==1)
            minValExI = minVTInd
        else
            TEx1 = size(minVTInd,1)
            TEx2 = ceil(TEx1/2);
            if(TEx2==0)
                TEx2 = 1
            end
            minValExI = minVTInd(TEx2)
        end
        setofIndmin = [setofIndmin;minValExI];  
        plot(minValExI,Cent(minValExI),'sk','linewidth',4)
        %pause
    end
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    saveas(gcf,CentroWidthSS)
    hold off
    
    %pause
    
      for j=1:size(setofIndmin,1)
                %j = 1
                j
                minind = setofIndmin(j)
                leftTemp = Cent(1:minind)
                
                if(isempty(leftTemp))
                    leftTempInd = minind
                else
                    leftTempM = max(leftTemp(:))
                    leftTempInd = find(leftTemp==leftTempM)
                    leftTempInd = leftTempInd(end)
                    
                    if(leftTempInd<1)
                        display('Precaution Left1!!!')
                        leftTempInd = 1
                        pause
                    end
                    
                    if(leftTempInd>szCent)
                        display('Precaution Left2!!!')
                        lefttTempInd = szCent
                        pause
                    end
                end
                
                
                
                %pause
%                 leftTemp = find(setofIndmax<minind)    
%                 if(isempty(leftTemp))
%                     leftTempInd = 1
%                 else
%                     leftTempInd = setofIndmax(leftTemp(end))
%                 end

                rightTemp = Cent(minind:szCent)
                
                if(isempty(rightTemp))
                    rightTempInd = minind
                else
                    rightTempM = max(rightTemp(:))
                    rightTempInd = find(rightTemp==rightTempM)
                    rightTempInd = minind+rightTempInd(1)-1
                    
                    if(rightTempInd<1)
                        display('Precaution Right1!!!')
                        rightTempInd = 1
                        pause
                    end
                    
                    if(rightTempInd>szCent)
                        display('Precaution Right2!!!')
                        rightTempInd = szCent
                        pause
                    end    
                end
                
                %pause
%                 if(isempty(rightTemp))
%                     rightTempInd = leng
%                 else
%                     rightTempInd = setofIndmax(rightTemp(1))
%                 end

                setofLeftind = [setofLeftind;leftTempInd];
                setofRightind = [setofRightind;rightTempInd];

                leftgap  = Cent(leftTempInd) - Cent(minind);
                rightgap = Cent(rightTempInd) - Cent(minind);
                totgap = leftgap+rightgap;
                
                if(totgap<0)
                    totgap = 0;
                end


                setofgaps    = [setofgaps;(totgap)];
                setofLeftgap = [setofLeftgap;leftgap];
                setofRightgap = [setofRightgap;rightgap];

                setofIndminV = [setofIndminV;Cent(minind)];

      end
      
      
%       for j=1:size(setofIndmin,1)
%                 %j = 1
%                 j
%                 minind = setofIndmin(j)
%                 leftTemp = find(setofIndmax<minind)    
%                 if(isempty(leftTemp))
%                     leftTempInd = 1
%                 else
%                     leftTempInd = setofIndmax(leftTemp(end))
%                 end
% 
%                 rightTemp = find(setofIndmax>minind)
%                 
%                 if(isempty(rightTemp))
%                     rightTempInd = leng
%                 else
%                     rightTempInd = setofIndmax(rightTemp(1))
%                 end
% 
%                 setofLeftind = [setofLeftind;leftTempInd];
%                 setofRightind = [setofRightind;rightTempInd];
% 
%                 leftgap  = Cent(leftTempInd) - Cent(minind);
%                 rightgap = Cent(rightTempInd) - Cent(minind);
%                 totgap = leftgap+rightgap;
%                 
%                 if(totgap<0)
%                     totgap = 0;
%                 end
% 
% 
%                 setofgaps    = [setofgaps;(totgap)];
%                 setofLeftgap = [setofLeftgap;leftgap];
%                 setofRightgap = [setofRightgap;rightgap];
% 
%                 setofIndminV = [setofIndminV;Cent(minind)];
% 
%       end
      
       
      Rmyfindminimas = [setofIndmin setofLeftind setofRightind setofLeftgap setofRightgap setofgaps setofIndminV]
      
      % KEY - 
      % setofIndmin    - Indices of minimas
      % setofLeftind   - Index of the left most maxima
      % setofRightind  - Index of the right most maxima
      % setofLeftgap   - Width Difference with the left side maxima
      % setofRightgap  - Width Difference with the right side maxima
      % setofgaps      - Width Difference from both sides (after setting
      % -ve s to ZERO
      % setofIndminV   - Width profile value at that place

   
        
