function [xn, yn] = rotatefunc(x, y)
% RotatingMeth2 - Tries out using the angle created by
% the end points.

%clc

x = round(x);
y = round(y);

delx = x(end)-x(1);
dely = y(end)-y(1);

if(delx==0)
    delx = 0.001;
end

Rangs = atan(dely./delx);
avgangs = Rangs;

%temp = (180*Rangs)/pi

    xn = x.*cos(-avgangs) - y.*sin(-avgangs);
    yn = x.*sin(-avgangs) + y.*cos(-avgangs);

% figure
% plot(x,y,'b')
% title('Original Curve');
% 
% 
% figure
% plot(xn,yn,'r')
% title('Rotated Curve');
