function [TCord] = thincord(BWthin)
%Author - Akila Mike Subasinghe
%Last modifies - 05-MAR-2010.
%
%When presented with a Binary image with a white (255 / 1) line segment,
%this program simply returns the xy coordinates (not ordered)

BWthin = double(BWthin);

szR = size(BWthin,1);

posLI = find(BWthin);

posInd = calcNormIndex(posLI,szR);

TCord = [posInd(:,2) posInd(:,1)];

